<?php
namespace OrganizationsManagement\Controller;
use Exception;
use OrganizationsManagement\Traits\TQuery;
use OrganizationsManagement\Traits\TResponse;
use OrganizationsManagement\Util\Utilities;
use Zeedhi\Framework\Controller\Simple;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource;
use OrganizationsManagement\Service;
use OrganizationsManagement\Util\InstanceProvider;
use OrganizationsManagement\Service\ConsultaOperadorSAAS as ConsultaOperadorSAASService;

class ConsultaOperadorSAAS extends Simple {

    use TResponse;

    /**
     * @var ConsultaOperadorSAASService
     */
    private $consultaOperadorSAASService;

    /**
     * ConsultaOperadorSAAS constructor.
     * @param ConsultaOperadorSAASService $consultaOperadorSAASService
     */
    public function __construct(ConsultaOperadorSAASService $consultaOperadorSAASService)
    {
        $this->consultaOperadorSAASService = $consultaOperadorSAASService;
    }

    /**
     * @param DTO\Request $request
     * @param DTO\Response $response
     * @throws Exception
     */
    public function findOrganization(DTO\Request $request, DTO\Response $response){
        try{
            $data = $this->consultaOperadorSAASService->findOrganization();
            $this->sendResponse($data, 200);
        }catch(Exception $ex){
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getOperadorSAAS(DTO\Request $request, DTO\Response $response)
    {
        try {
            $data = $this->consultaOperadorSAASService->getOperadorSAAS();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}