<?php

namespace OrganizationsManagement\Repository;

use Doctrine\ORM\EntityManager;
use Teknisa\Model\Traits\TQuery;

class RedirecionamentoProduto
{
    use TQuery;
    /**
     * @var EntityManager
     */
    private $entityManager;

    /**
     * RedirecionamentoProduto constructor.
     * @param EntityManager $entityManager
     */
    public function __construct(EntityManager $entityManager)
    {
        $this->entityManager = $entityManager;
    }

    public function redirecionamentoProduto()
    {
        $query = <<<SQL
            SELECT O.NRORG, O.NMORGANIZACAO, O.NMRAZSOCIALORG, OP.NMPRODUTO, OP.ID, DECODE(O.NRORGPRINCIPAL, NULL, 'P', 'S') AS IS_PRIMARY,
                DECODE(O.NRORGPRINCIPAL, NULL, O.IDORGSAAS, OM.IDORGSAAS) AS IDORGSAAS, OG.DSURLREDIRECT, OG.IDUTREDIRECTRC,
                OG.ID AS ORGIDPRODUCT
            FROM ORGANIZACAO O
            LEFT JOIN OM_PRODUTO_ORG OG ON OG.NRORG_ID = O.NRORG
            LEFT JOIN OM_PRODUTO OP ON OP.ID = OG.NRPRODUTO_ID
            LEFT JOIN ORGANIZACAO OM ON O.NRORGPRINCIPAL = OM.NRORG
            WHERE OG.ID IS NOT NULL
        
SQL;
        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $query);
    }
}
