<?php

namespace OrganizationsManagement\Service;

use Doctrine\ORM\EntityManager;
use OrganizationsManagement\Repository\RedirecionamentoProduto as RedirecionamentoProdutoRepository;
use OrganizationsManagement\Util\InstanceProvider;


class RedirecionamentoProduto
{
    /**
     * @var EntityManager
     */
    private $entityManager;
    /**
     * @var RedirecionamentoProdutoRepository
     */
    private $redirecionamentoProdutoRepository;

    public function __construct(EntityManager $entityManager, RedirecionamentoProdutoRepository $redirecionamentoProdutoRepository)
    {
        $this->entityManager = $entityManager;
        $this->redirecionamentoProdutoRepository = $redirecionamentoProdutoRepository;
    }

    public function redirecionamentoProduto()
    {
        return $this->redirecionamentoProdutoRepository->redirecionamentoProduto();
    }

    public function saveRedirecionamentoProduto($rows, $stageRedirect)
    {
        $connection = $this->entityManager->getConnection();
        $productOrgRepository = InstanceProvider::getRepository()->getOmProdutoOrg();
        try {
            $connection->beginTransaction();
                foreach ($rows as $row) {
                    $productOrgEntity = $productOrgRepository->findOneBy(array('id' => $row['ORGIDPRODUCT']));
                    if ($productOrgEntity !== null) {
                        if ($stageRedirect == null) {
                            $productOrgEntity->setDsurlredirect($row['DSURLREDIRECT']);
                            $productOrgEntity->setIdutredirectrc($row['IDUTREDIRECTRC']);
                        } else if ($stageRedirect == 'ADD') {
                            $productOrgEntity->setIdutredirectrc('S');
                        } else if ($stageRedirect == 'REMOVE') {
                            $productOrgEntity->setIdutredirectrc('N');
                        }
                        $this->entityManager->persist($productOrgEntity);
                        $this->entityManager->flush();
                    }
                }
            $connection->commit();
        } catch (\Exception $ex) {
            $connection->rollback();
            throw $ex;
        }
    }
}
