CREATE OR REPLACE FUNCTION SPED_BLOCOK(
   P_CDEMPRESA    IN EMPRESA.CDEMPRESA%TYPE,
   P_CDINSCESTA   IN EMPRESA.CDINSCESTA%TYPE,
   P_DTINICIAL    IN NOTAFISCAL.DTENTRSAID%TYPE,
   P_DTFINAL      IN NOTAFISCAL.DTENTRSAID%TYPE,
   P_NRSEQARQMAG  IN ARQMAGNETICO.NRSEQARQMAG%TYPE,
   P_LIVROMAG     IN LIVROMAGNETICO.CDLIVROMAG%TYPE,
   P_GERABLOCOK   IN DADOSGERSPED.IDGERABLOCOK%TYPE,
   P_ORIGBLOCOK   IN DADOSGERSPED.IDORIGBLOCOK%TYPE,
   P_TOTALIZA     IN NUMBER,
   P_IDCONSPRODEXT IN VARCHAR2,
   P_VERSAO        IN VARCHAR2) RETURN VARCHAR
AS
   V_CONTREGK     NUMBER;
   V_MOVIMENT     NUMBER;
   V_PRODUTO      VARCHAR2(10);
   V_SEQUPROD     NUMBER;
   V_UNID         VARCHAR2(100);
   V_SGUNIDADE    VARCHAR2(100);
   V_COD_PAR      VARCHAR2(100);
   V_CLIENT_INFO  VARCHAR2(64);
   V_CDOPERADOR   OPERADOR.CDOPERADOR%TYPE;
   V_SEQUMOVI     VARCHAR2(20);
   V_PARTICIPANTE VARCHAR2(50);
   V_IDAGENTERC   VARCHAR2(01);
BEGIN
   V_SEQUPROD := NVL(P_TOTALIZA,0);

   IF P_GERABLOCOK IN ('S','E', 'P') THEN

      /*REGISTRO K100 - PERODO DE APURAO*/
      V_CONTREGK := NVL(V_CONTREGK,0) + 1;
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        ('75'||LPAD(RTRIM(V_CONTREGK),8,'0'), '|K100'||'|'||TO_CHAR(P_DTINICIAL,'DDMMYYYY')||'|'||TO_CHAR(P_DTFINAL,'DDMMYYYY')||'|', P_NRSEQARQMAG);

      BEGIN
         SELECT MAX('S')
           INTO V_IDAGENTERC
           FROM AGENTETERCECLI A, FILIAL F
          WHERE A.CDFILIAL   = F.CDFILIAL
            AND F.CDEMPRESA  = P_CDEMPRESA
            AND F.CDINSCESTA = P_CDINSCESTA;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_IDAGENTERC := 'N';
      END;

      IF NVL(V_IDAGENTERC,'N') = 'N' THEN
         BEGIN
            SELECT MAX('S')
              INTO V_IDAGENTERC
              FROM AGENTETERCEFOR A, FILIAL F
             WHERE A.CDFILIAL   = F.CDFILIAL
               AND F.CDEMPRESA  = P_CDEMPRESA
               AND F.CDINSCESTA = P_CDINSCESTA;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_IDAGENTERC := 'N';
         END;
      END IF;
      /*REGISTRO K200: ESTOQUE ESCRITURADO*/
      IF NVL(V_IDAGENTERC,'N') = 'S' THEN  /*QUANDO EXISTE AGENTE DE TERCEIRIZAO NA BASE*/
         FOR C_REGK200 IN (SELECT '|K200'                                  ||'|'||
                                  NVL(TO_CHAR(P_DTFINAL,'DDMMYYYY'),'')    ||'|'||
                                  E.CDARVPROD                              ||'|'||
                                  REPLACE(LTRIM(TO_CHAR(NVL(ROUND(E.QTD,3),0), '999999999990.000')), '.', ',') ||'|'||
                                  E.IND_EST                                ||'|' AS ARQ_K200,
                                  --REPLACE(REPLACE(REPLACE(REPLACE(E.IDPARTICIPANTE||E.PARTICIPANTE,'.'),'-'),'/'),' ') ||'|'
                                  E.CDPRODUTO, E.IDPARTICIPANTE||E.PARTICIPANTE AS PARTICIPANTE, E.CDARVPROD AS COD_ITEM
                             FROM (SELECT B.CDPRODUTO,
                                          DECODE(P_IDCONSPRODEXT, 'S', DECODE(PF.IDUTCDEXTPRONF,'S',NVL(A.CDPRODINTE,A.CDARVPROD),A.CDARVPROD),A.CDARVPROD) AS CDARVPROD,
                                          FC.NRINSJUR, FC.PARTICIPANTE, FC.IDPARTICIPANTE,
                                          SUM(B.QTESTOQDIA) AS QTD, CASE WHEN NVL(FC.CDALMOXINFO,  'X') <> 'X' THEN '1'
                                                          WHEN NVL(FC.CDALMOXTERC,  'X') <> 'X' THEN '2'
                                                          WHEN NVL(FC.CDALMOXARIFE, 'X') <> 'X' THEN '2'
                                                          ELSE '0' END IND_EST
                                   FROM ALMOXARIFADO AL, FILIAL F, LOCALESTOQUE LE, RELACPRODITGEN R, TIPOITEMBLOCOK T, PRODUTO A, PARAMFILIAL PF,
                                        POSESTDIA B LEFT JOIN (SELECT CDFILIAL, PARTICIPANTE, MAX(IDPARTICIPANTE) AS IDPARTICIPANTE, CDALMOXARIFE,
                                                                      CDLOCALESTOQ, NRINSJUR, CDALMOXTERC, CDLOCALTERC, CDALMOXINFO, CDLOCALINFO
                                                                 FROM (SELECT A.CDFILIAL, A.CDCLIENTE AS PARTICIPANTE, 'C' AS IDPARTICIPANTE, A.CDALMOXARIFE,
                                                                              A.CDLOCALESTOQ, C.NRINSJURCLIE AS NRINSJUR,
                                                                              A.CDALMOXTERCCLI CDALMOXTERC, A.CDLOCALTERCCLI CDLOCALTERC,
                                                                              A.CDALMOXINFOCLI CDALMOXINFO, A.CDLOCALINFOCLI CDLOCALINFO
                                                                         FROM AGENTETERCECLI A, CLIENTE C
                                                                        WHERE A.CDCLIENTE  = C.CDCLIENTE
                                                                        UNION ALL
                                                                       SELECT A.CDFILIAL, A.CDFORNECED AS PARTICIPANTE, 'F' AS IDPARTICIPANTE, A.CDALMOXARIFE,
                                                                              A.CDLOCALESTOQ, C.NRINSJURFORN AS NRINSJUR,
                                                                              A.CDALMOXTERCFOR CDALMOXTERC, A.CDLOCALTERCFOR CDLOCALTERC,
                                                                              A.CDALMOXINFOFOR CDALMOXINFO, A.CDLOCALINFOFOR CDLOCALINFO
                                                                         FROM AGENTETERCEFOR A, FORNECEDOR C
                                                                        WHERE A.CDFORNECED = C.CDFORNECED)
                                                                GROUP BY CDFILIAL, PARTICIPANTE, CDALMOXARIFE, CDLOCALESTOQ, NRINSJUR,
                                                                         CDALMOXTERC, CDLOCALTERC, CDALMOXINFO, CDLOCALINFO) FC ON (FC.CDFILIAL       = B.CDFILIAL AND
                                                                                                                       ((FC.CDALMOXARIFE = B.CDALMOXARIFE AND
                                                                                                                         FC.CDLOCALESTOQ = B.CDLOCALESTOQ) OR
                                                                                                                        (FC.CDALMOXTERC  = B.CDALMOXARIFE AND
                                                                                                                         FC.CDLOCALTERC  = B.CDLOCALESTOQ) OR
                                                                                                                        (FC.CDALMOXINFO  = B.CDALMOXARIFE AND
                                                                                                                         FC.CDLOCALINFO  = B.CDLOCALESTOQ)))
                           WHERE ABS(B.QTESTOQDIA) > 0.00001
                           AND B.CDFILIAL      = F.CDFILIAL
                           AND F.CDEMPRESA     = P_CDEMPRESA
                           AND F.CDINSCESTA    = P_CDINSCESTA
                           AND B.CDFILIAL      = AL.CDFILIAL
                           AND B.CDALMOXARIFE  = AL.CDALMOXARIFE
                           AND LE.CDFILIAL     = B.CDFILIAL
                           AND LE.CDALMOXARIFE = B.CDALMOXARIFE
                           AND LE.CDLOCALESTOQ = B.CDLOCALESTOQ
                           AND B.CDPRODUTO     = A.CDPRODUTO
                           AND A.CDPRODUTO     = A.CDPRODESTO
                           AND A.CDPRODUTO     = R.CDPRODUTO
                           AND R.CDLIVROMAG    = P_LIVROMAG
                           AND R.CDTPITEMPROD  = T.CDTPITEMPROD
                           AND T.IDITEMESTOQUE = 'S'
                           AND PF.CDFILIAL     = F.CDFILIAL
                           AND B.DTPOSIESTQ    = DTPOSICAO_POSESTDIA(B.CDFILIAL, A.CDPRODESTO, B.CDALMOXARIFE, B.CDLOCALESTOQ, B.NRLOTEESTQ, B.NRSUBLOTE, TO_DATE(P_DTFINAL)+1)
                  GROUP BY DECODE(P_IDCONSPRODEXT, 'S', DECODE(PF.IDUTCDEXTPRONF,'S',NVL(A.CDPRODINTE,A.CDARVPROD),A.CDARVPROD),A.CDARVPROD), B.CDPRODUTO, FC.PARTICIPANTE, FC.IDPARTICIPANTE,
                        CASE WHEN NVL(FC.CDALMOXINFO,  'X') <> 'X' THEN '1'
                             WHEN NVL(FC.CDALMOXTERC,  'X') <> 'X' THEN '2'
                             WHEN NVL(FC.CDALMOXARIFE, 'X') <> 'X' THEN '2'
                             ELSE '0' END, FC.NRINSJUR)E) LOOP

            V_PARTICIPANTE := '';
            /* CODIGO DO PARTICIPANTE */
            SELECT MAX(CDCHAVEREG)
              INTO V_COD_PAR
              FROM TMP_REGDADOSSPED
             WHERE CDCHAVEREG = C_REGK200.PARTICIPANTE
               AND CDREGISTRO = '0150';

            IF (V_COD_PAR IS NULL) AND (C_REGK200.PARTICIPANTE IS NOT NULL) THEN
               V_PARTICIPANTE := RETORNA_PARTICIPANTE_SPED(C_REGK200.PARTICIPANTE);
               IF V_PARTICIPANTE IS NULL THEN
                  V_SEQUPROD := NVL(V_SEQUPROD,0) + 1;
                  INSERT INTO TMP_REGDADOSSPED
                    (CDREGISTRO, CDCONTREGI, CDCHAVEREG)
                  VALUES
                    ('0150', V_SEQUPROD, C_REGK200.PARTICIPANTE);
               END IF;
            END IF;

            V_PARTICIPANTE := REPLACE(REPLACE(REPLACE(REPLACE(NVL(V_PARTICIPANTE,C_REGK200.PARTICIPANTE),'.'),'-'),'/'),' ')||'|';

            /*CDIGO DO PRODUTO*/
            SELECT MAX(CDCHAVEREG)
              INTO V_PRODUTO
              FROM TMP_REGDADOSSPED
             WHERE CDCHAVEREG = C_REGK200.CDPRODUTO
               AND CDREGISTRO = '0200';

            IF (V_PRODUTO IS NULL) AND (C_REGK200.CDPRODUTO IS NOT NULL) THEN
               V_SEQUPROD := NVL(V_SEQUPROD,0) + 1;
               INSERT INTO TMP_REGDADOSSPED
                  (CDREGISTRO, CDCONTREGI, CDCHAVEREG, CDCAMPO4)
               VALUES
                  ('0200', V_SEQUPROD, C_REGK200.CDPRODUTO, C_REGK200.COD_ITEM);
            END IF;

            /*UNIDADE DE MEDIDA */
            BEGIN
               SELECT SGUNIDADE
                 INTO V_SGUNIDADE
                 FROM PRODUTO
                WHERE CDPRODUTO = C_REGK200.CDPRODUTO;
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                  V_SGUNIDADE := NULL;
            END;

            SELECT MAX(CDCHAVEREG)
              INTO V_UNID
              FROM TMP_REGDADOSSPED
             WHERE CDCHAVEREG = V_SGUNIDADE
               AND CDREGISTRO = '0190';

            IF (V_UNID IS NULL) AND (V_SGUNIDADE IS NOT NULL) THEN
                V_SEQUPROD := NVL(V_SEQUPROD,0) + 1;
                INSERT INTO TMP_REGDADOSSPED
                  (CDREGISTRO, CDCONTREGI, CDCHAVEREG)
                VALUES
                  ('0190', V_SEQUPROD, V_SGUNIDADE);
            END IF;
            V_UNID := NULL;

            V_CONTREGK := NVL(V_CONTREGK,0) + 1;
            INSERT INTO ARQMAGNETICO
               (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
            VALUES
               ('75'||LPAD(RTRIM(V_CONTREGK), 8, '0'), C_REGK200.ARQ_K200||V_PARTICIPANTE, P_NRSEQARQMAG);
         END LOOP;
      ELSE   /*QUANDO O CLIENTE NO TRABALHA COM AGENTE DE TERCEIRIZAO*/
         FOR C_REGK200 IN (SELECT '|K200'                                  ||'|'||
                                  NVL(TO_CHAR(P_DTFINAL,'DDMMYYYY'),'')    ||'|'||
                                  E.CDARVPROD                              ||'|'||
                                  REPLACE(LTRIM(TO_CHAR(NVL(ROUND(E.QTD,3),0), '999999999990.000')), '.', ',') ||'|'||
                                  E.IND_EST                                ||'|' AS ARQ_K200,
                                  E.CDPRODUTO, E.CDARVPROD AS COD_ITEM
                             FROM (SELECT B.CDPRODUTO, DECODE(P_IDCONSPRODEXT, 'S', DECODE(PF.IDUTCDEXTPRONF,'S',NVL(A.CDPRODINTE,A.CDARVPROD),A.CDARVPROD),A.CDARVPROD) AS CDARVPROD,
                                          SUM(B.QTESTOQDIA) AS QTD, '0' AS IND_EST
                                     FROM ALMOXARIFADO AL, FILIAL F, LOCALESTOQUE LE, RELACPRODITGEN R, TIPOITEMBLOCOK T, PRODUTO A, PARAMFILIAL PF, POSESTDIA B
                                    WHERE ABS(B.QTESTOQDIA) > 0.00001
                                      AND B.CDFILIAL      = F.CDFILIAL
                                      AND F.CDEMPRESA     = P_CDEMPRESA
                                      AND F.CDINSCESTA    = P_CDINSCESTA
                                      AND B.CDFILIAL      = AL.CDFILIAL
                                      AND B.CDALMOXARIFE  = AL.CDALMOXARIFE
                                      AND LE.CDFILIAL     = B.CDFILIAL
                                      AND LE.CDALMOXARIFE = B.CDALMOXARIFE
                                      AND LE.CDLOCALESTOQ = B.CDLOCALESTOQ
                                      AND B.CDPRODUTO     = A.CDPRODUTO
                                      AND A.CDPRODUTO     = A.CDPRODESTO
                                      AND A.CDPRODUTO     = R.CDPRODUTO
                                      AND R.CDLIVROMAG    = P_LIVROMAG
                                      AND R.CDTPITEMPROD  = T.CDTPITEMPROD
                                      AND T.IDITEMESTOQUE = 'S'
                                      AND PF.CDFILIAL     = F.CDFILIAL
                                      AND B.DTPOSIESTQ    = DTPOSICAO_POSESTDIA(B.CDFILIAL, A.CDPRODESTO, B.CDALMOXARIFE, B.CDLOCALESTOQ, B.NRLOTEESTQ, B.NRSUBLOTE, TO_DATE(P_DTFINAL)+1)
                                    GROUP BY DECODE(P_IDCONSPRODEXT, 'S', DECODE(PF.IDUTCDEXTPRONF,'S',NVL(A.CDPRODINTE,A.CDARVPROD),A.CDARVPROD),A.CDARVPROD), B.CDPRODUTO)E) LOOP

            /*CDIGO DO PRODUTO*/
            SELECT MAX(CDCHAVEREG)
              INTO V_PRODUTO
              FROM TMP_REGDADOSSPED
             WHERE CDCHAVEREG = C_REGK200.CDPRODUTO
               AND CDREGISTRO = '0200';

            IF (V_PRODUTO IS NULL) AND (C_REGK200.CDPRODUTO IS NOT NULL) THEN
               V_SEQUPROD := NVL(V_SEQUPROD,0) + 1;
               INSERT INTO TMP_REGDADOSSPED
                  (CDREGISTRO, CDCONTREGI, CDCHAVEREG, CDCAMPO4)
               VALUES
                  ('0200', V_SEQUPROD, C_REGK200.CDPRODUTO, C_REGK200.COD_ITEM);
            END IF;

            /*UNIDADE DE MEDIDA */
            BEGIN
               SELECT SGUNIDADE
                 INTO V_SGUNIDADE
                 FROM PRODUTO
                WHERE CDPRODUTO = C_REGK200.CDPRODUTO;
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                  V_SGUNIDADE := NULL;
            END;

            SELECT MAX(CDCHAVEREG)
              INTO V_UNID
              FROM TMP_REGDADOSSPED
             WHERE CDCHAVEREG = V_SGUNIDADE
               AND CDREGISTRO = '0190';

            IF (V_UNID IS NULL) AND (V_SGUNIDADE IS NOT NULL) THEN
                V_SEQUPROD := NVL(V_SEQUPROD,0) + 1;
                INSERT INTO TMP_REGDADOSSPED
                  (CDREGISTRO, CDCONTREGI, CDCHAVEREG)
                VALUES
                  ('0190', V_SEQUPROD, V_SGUNIDADE);
            END IF;
            V_UNID := NULL;

            V_PARTICIPANTE := '|';

            V_CONTREGK := NVL(V_CONTREGK,0) + 1;
            INSERT INTO ARQMAGNETICO
               (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
            VALUES
               ('75'||LPAD(RTRIM(V_CONTREGK), 8, '0'), C_REGK200.ARQ_K200||V_PARTICIPANTE, P_NRSEQARQMAG);
         END LOOP;
      END IF;

      IF P_GERABLOCOK = 'S' THEN
         /*REGISTRO K220: OUTRAS MOVIMENTAES INTERNAS ENTRE MERCADORIAS*/
         --No Ser Implementado, ainda no existe a reclassificao de produtos no Sistema

         /*CASO GERE O ARQUIVO COM INFORMAES DO PLANEJAMENTO ALIMENTAR, DEVE GRAVAR A TABELA COM A RECEITA PADRO*/
         IF P_ORIGBLOCOK IN ('0','2') THEN
            DBMS_APPLICATION_INFO.READ_CLIENT_INFO(V_CLIENT_INFO);
            V_CDOPERADOR := SUBSTR(V_CLIENT_INFO,1,12);
            BLOCOK_PROD_PLANEJ(P_CDEMPRESA, P_CDINSCESTA, P_DTINICIAL, P_DTFINAL, V_CDOPERADOR);
         END IF;

         /*REGISTRO K230: ITENS PRODUZIDOS*/
         FOR C_REGK230 IN (SELECT '|K230'                                  ||'|'||
                                  NVL(TO_CHAR(P.DTINICIOOP,'DDMMYYYY'),'') ||'|'||
                                  CASE WHEN (P.DTFINALOP > P_DTFINAL OR P.DTFINALOP IS NULL)
                                        THEN ''
                                        ELSE TO_CHAR(P.DTFINALOP, 'DDMMYYYY') END ||'|'||
                                  P.NRORDPROD                              ||'|'||
                                  DECODE(P_IDCONSPRODEXT, 'S', DECODE(PF.IDUTCDEXTPRONF,'S',NVL(PR.CDPRODINTE,PR.CDARVPROD),PR.CDARVPROD),PR.CDARVPROD) ||'|'||
                                  REPLACE(LTRIM(TO_CHAR(NVL(SUM(ROUND(CASE WHEN P.DTPRODACABADO BETWEEN P_DTINICIAL AND P_DTFINAL
                                                                       THEN P.QTPRACABADO ELSE 0 END,6)),0), '999999999990.000000')), '.', ',') ||'|' AS ARQ_K230,
                                  P.NRORDPROD, P.CDPRODUTO, TO_DATE('') AS DTRETIRADA, '' AS CDFILIAL,
                                  '' AS CDSERVFILI, '' AS CDFILANCESTQ, '' AS NRLANCESTQ,'P' AS IDORIGEM,
                                  DECODE(P_IDCONSPRODEXT, 'S', DECODE(PF.IDUTCDEXTPRONF,'S',NVL(PR.CDPRODINTE,PR.CDARVPROD),PR.CDARVPROD),PR.CDARVPROD) AS COD_ITEM
                             FROM BLOCOK_PRODUCAO_K230 P, PRODUTO PR, PARAMFILIAL PF
                            WHERE P.CDEMPRESA    = P_CDEMPRESA
                              AND P.CDINSCESTA   = P_CDINSCESTA
                              AND ((P.DTPRODACABADO BETWEEN P_DTINICIAL AND P_DTFINAL) OR
                                   (P.DTSAIDAEST    BETWEEN P_DTINICIAL AND P_DTFINAL))
                              AND P.CDPRODINSUMO IS NULL
                              AND P_ORIGBLOCOK IN ('1','2')
                              AND P.CDPRODUTO = PR.CDPRODUTO
                              AND PF.CDFILIAL = P.CDFILIAL
                              GROUP BY NVL(TO_CHAR(P.DTINICIOOP,'DDMMYYYY'),''), CASE WHEN (P.DTFINALOP > P_DTFINAL OR P.DTFINALOP IS NULL)
                                        THEN ''
                                        ELSE TO_CHAR(P.DTFINALOP, 'DDMMYYYY') END,
                                       P.NRORDPROD, P.CDPRODUTO,
                                       DECODE(P_IDCONSPRODEXT, 'S', DECODE(PF.IDUTCDEXTPRONF,'S',NVL(PR.CDPRODINTE,PR.CDARVPROD),PR.CDARVPROD),PR.CDARVPROD)
                            UNION ALL
                           SELECT '|K230'                                  ||'|'||
                                  NVL(TO_CHAR(A.DTRETIRADA,'DDMMYYYY'),'') ||'|'||
                                  NVL(TO_CHAR(A.DTRETIRADA,'DDMMYYYY'),'') ||'|'||
                                  A.NRPRODUCAO                             ||'|'||
                                  DECODE(P_IDCONSPRODEXT, 'S', DECODE(PF.IDUTCDEXTPRONF,'S',NVL(P.CDPRODINTE,A.CDARVPRODACAB),A.CDARVPRODACAB),A.CDARVPRODACAB)||'|'||
                                  REPLACE(LTRIM(TO_CHAR(NVL(ROUND(A.QTEFETIVOS,6),0), '999999999990.000000')), '.', ',') ||'|' AS ARQ_K230,
                                  TO_CHAR(A.NRPRODUCAO) AS NRORDPROD, A.CDPRODACABADO AS CDPRODUTO, A.DTRETIRADA, A.CDFILIAL,
                                  A.CDSERVFILI, A.CDFILANCESTQ, A.NRLANCESTQ, 'A' AS IDORIGEM,
                                  DECODE(P_IDCONSPRODEXT, 'S', DECODE(PF.IDUTCDEXTPRONF,'S',NVL(P.CDPRODINTE,A.CDARVPRODACAB),A.CDARVPRODACAB),A.CDARVPRODACAB) AS COD_ITEM
                             FROM TABLE(BLOCOK_PROD_REAL_PAI(P_CDINSCESTA,P_CDEMPRESA,P_DTINICIAL,P_DTFINAL,P_LIVROMAG))A, PRODUTO P, PARAMFILIAL PF
                            WHERE ROUND(A.QTEFETIVOS,6) > 0
                              AND P_ORIGBLOCOK IN ('0','2')
                              AND A.CDPRODACABADO = P.CDPRODUTO
                              AND PF.CDFILIAL     = A.CDFILIAL) LOOP

             /*CDIGO DO PRODUTO*/
             SELECT MAX(CDCHAVEREG)
               INTO V_PRODUTO
               FROM TMP_REGDADOSSPED
              WHERE CDCHAVEREG = C_REGK230.CDPRODUTO
                AND CDREGISTRO = '0200';

             IF (C_REGK230.CDPRODUTO IS NOT NULL) THEN
                IF (V_PRODUTO IS NULL) THEN
                   V_SEQUPROD := NVL(V_SEQUPROD,0) + 1;
                   INSERT INTO TMP_REGDADOSSPED
                      (CDREGISTRO, CDCONTREGI, CDCHAVEREG, CDCAMPO1, CDCAMPO4)
                   VALUES
                      ('0200', V_SEQUPROD, C_REGK230.CDPRODUTO, 'S', C_REGK230.COD_ITEM);
                ELSE
                   UPDATE TMP_REGDADOSSPED
                      SET CDCAMPO1   = 'S'
                    WHERE CDCHAVEREG = C_REGK230.CDPRODUTO
                      AND CDREGISTRO = '0200';
                END IF;
             END IF;

             /*UNIDADE DE MEDIDA */
             BEGIN
                SELECT SGUNIDADE
                  INTO V_SGUNIDADE
                  FROM PRODUTO
                 WHERE CDPRODUTO = C_REGK230.CDPRODUTO;
             EXCEPTION
                WHEN NO_DATA_FOUND THEN
                   V_SGUNIDADE := NULL;
             END;

             SELECT MAX(CDCHAVEREG)
               INTO V_UNID
               FROM TMP_REGDADOSSPED
              WHERE CDCHAVEREG = V_SGUNIDADE
                AND CDREGISTRO = '0190';

             IF (V_UNID IS NULL) AND (V_SGUNIDADE IS NOT NULL) THEN
                V_SEQUPROD := NVL(V_SEQUPROD,0) + 1;
                INSERT INTO TMP_REGDADOSSPED
                  (CDREGISTRO, CDCONTREGI, CDCHAVEREG)
                VALUES
                  ('0190', V_SEQUPROD, V_SGUNIDADE);
             END IF;
             V_UNID := NULL;

             V_CONTREGK := NVL(V_CONTREGK,0) + 1;
             INSERT INTO ARQMAGNETICO
                (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
             VALUES
                ('75'||LPAD(RTRIM(V_CONTREGK), 8, '0'), C_REGK230.ARQ_K230, P_NRSEQARQMAG);

             IF P_GERABLOCOK <> 'P' THEN
                FOR C_REGK235 IN (SELECT '|K235'                                  ||'|'||
                                         NVL(TO_CHAR(P.DTSAIDAEST,'DDMMYYYY'),'') ||'|'||
                                         DECODE(P_IDCONSPRODEXT, 'S', DECODE(PF.IDUTCDEXTPRONF,'S',NVL(PR.CDPRODINTE,P.CDARVPRODINSU),P.CDARVPRODINSU),P.CDARVPRODINSU)||'|'||
                                         REPLACE(LTRIM(TO_CHAR(SUM(NVL(ROUND(P.QTRETINSUMO,6),0)), '999999999990.000000')), '.', ',') ||'|'||
                                         CASE WHEN TO_NUMBER(P_VERSAO) < 16 THEN CDINSUMOSUBST ||'|' ELSE '' END ||'|' AS ARQ_K235,
                                         P.CDPRODINSUMO, DECODE(P_IDCONSPRODEXT, 'S', DECODE(PF.IDUTCDEXTPRONF,'S',NVL(PR.CDPRODINTE,P.CDARVPRODINSU),P.CDARVPRODINSU),P.CDARVPRODINSU) AS COD_ITEM
                                    FROM BLOCOK_PRODUCAO_K230 P, PRODUTO PR, PARAMFILIAL PF
                                   WHERE P.CDEMPRESA    = P_CDEMPRESA
                                     AND P.CDINSCESTA   = P_CDINSCESTA
                                     AND P.DTSAIDAEST   BETWEEN P_DTINICIAL AND P_DTFINAL
                                     AND P.NRORDPROD    = C_REGK230.NRORDPROD
                                     AND P.CDPRODUTO    = C_REGK230.CDPRODUTO
                                     AND P.CDPRODINSUMO IS NOT NULL
                                     AND C_REGK230.IDORIGEM = 'P'
                                     AND P_ORIGBLOCOK IN ('1','2')
                                     AND P.CDPRODUTO = PR.CDPRODUTO
                                     AND PF.CDFILIAL = P.CDFILIAL
                                     GROUP BY P.DTSAIDAEST, P.CDARVPRODINSU, P.CDINSUMOSUBST, P.CDPRODINSUMO, DECODE(P_IDCONSPRODEXT, 'S', DECODE(PF.IDUTCDEXTPRONF,'S',NVL(PR.CDPRODINTE,P.CDARVPRODINSU),P.CDARVPRODINSU),P.CDARVPRODINSU)
                                   UNION ALL
                                  SELECT '|K235'                                  ||'|'||
                                         NVL(TO_CHAR(C_REGK230.DTRETIRADA,'DDMMYYYY'),'') ||'|'||
                                         DECODE(P_IDCONSPRODEXT, 'S', DECODE(PF.IDUTCDEXTPRONF,'S',NVL(PR.CDPRODINTE,PR.CDARVPROD),PR.CDARVPROD),PR.CDARVPROD)||'|'||
                                         REPLACE(LTRIM(TO_CHAR(NVL(ROUND(A.QTRETIRADA,6),0), '999999999990.000000')), '.', ',') ||'|'||
                                         ''                                       ||'|' AS ARQ_K235,
                                         A.CDPRODUTO, DECODE(P_IDCONSPRODEXT, 'S', DECODE(PF.IDUTCDEXTPRONF,'S',NVL(PR.CDPRODINTE,PR.CDARVPROD),PR.CDARVPROD),PR.CDARVPROD) AS COD_ITEM
                                    FROM TABLE(BLOCOK_PROD_REAL_FILHO(P_CDINSCESTA, P_CDEMPRESA, P_DTINICIAL, P_DTFINAL, C_REGK230.DTRETIRADA,
                                                                      C_REGK230.CDFILIAL, C_REGK230.CDSERVFILI, C_REGK230.CDFILANCESTQ, C_REGK230.NRLANCESTQ, P_LIVROMAG)) A,
                                         PRODUTO PR, PARAMFILIAL PF
                                   WHERE C_REGK230.IDORIGEM = 'A'
                                     AND ROUND(A.QTRETIRADA,3) > 0
                                     AND P_ORIGBLOCOK IN ('0','2')
                                     AND A.CDPRODUTO = PR.CDPRODUTO
                                     AND PF.CDFILIAL = C_REGK230.CDFILIAL) LOOP
                   /*CDIGO DO PRODUTO*/
                   SELECT MAX(CDCHAVEREG)
                     INTO V_PRODUTO
                     FROM TMP_REGDADOSSPED
                    WHERE CDCHAVEREG = C_REGK235.CDPRODINSUMO
                      AND CDREGISTRO = '0200';

                   IF (V_PRODUTO IS NULL) AND (C_REGK235.CDPRODINSUMO IS NOT NULL) THEN
                      V_SEQUPROD := NVL(V_SEQUPROD,0) + 1;
                      INSERT INTO TMP_REGDADOSSPED
                         (CDREGISTRO, CDCONTREGI, CDCHAVEREG, CDCAMPO4)
                      VALUES
                         ('0200', V_SEQUPROD, C_REGK235.CDPRODINSUMO, C_REGK235.COD_ITEM);
                   END IF;

                   /*UNIDADE DE MEDIDA */
                   BEGIN
                      SELECT SGUNIDADE
                        INTO V_SGUNIDADE
                        FROM PRODUTO
                       WHERE CDPRODUTO = C_REGK235.CDPRODINSUMO;
                   EXCEPTION
                      WHEN NO_DATA_FOUND THEN
                         V_SGUNIDADE := NULL;
                   END;

                   SELECT MAX(CDCHAVEREG)
                     INTO V_UNID
                     FROM TMP_REGDADOSSPED
                    WHERE CDCHAVEREG = V_SGUNIDADE
                      AND CDREGISTRO = '0190';

                   IF (V_UNID IS NULL) AND (V_SGUNIDADE IS NOT NULL) THEN
                      V_SEQUPROD := NVL(V_SEQUPROD,0) + 1;
                      INSERT INTO TMP_REGDADOSSPED
                        (CDREGISTRO, CDCONTREGI, CDCHAVEREG)
                      VALUES
                        ('0190', V_SEQUPROD, V_SGUNIDADE);
                   END IF;
                   V_UNID := NULL;

                   V_CONTREGK := NVL(V_CONTREGK,0) + 1;
                   INSERT INTO ARQMAGNETICO
                      (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
                   VALUES
                      ('75'||LPAD(RTRIM(V_CONTREGK), 8, '0'), C_REGK235.ARQ_K235, P_NRSEQARQMAG);
                END LOOP;
             END IF;
         END LOOP;

         FOR C_REGK250 IN (SELECT '|K250'                                  ||'|'||
                                  NVL(TO_CHAR(N.DTENTRSAID,'DDMMYYYY'),'') ||'|'||
                                  DECODE(P_IDCONSPRODEXT, 'S', DECODE(PF.IDUTCDEXTPRONF,'S',NVL(P.CDPRODINTE,P.CDARVPROD),P.CDARVPROD),P.CDARVPROD)||'|'||
                                  REPLACE(LTRIM(TO_CHAR(NVL(SUM(ROUND(I.QTITEMPROD,6)),0), '999999999990.000000')), '.', ',') ||'|' AS ARQ_K250,
                                  N.NRLANCTONF, N.CDFILIAL, N.DTENTRSAID, P.CDPRODUTO, I.CDPRODNCMTRANS AS CDCLASFISC, PF.IDUTCDEXTPRONF AS IDUTCDEXTPRONF,
                                  DECODE(P_IDCONSPRODEXT, 'S', DECODE(PF.IDUTCDEXTPRONF,'S',NVL(P.CDPRODINTE,P.CDARVPROD),P.CDARVPROD),P.CDARVPROD) AS COD_ITEM
                             FROM NOTAFISCAL N, ITEMPRODUTO I, TIPOOPERAC T, TPOPERCFOP O, PRODUTO P, PARAMFILIAL PF
                            WHERE N.CDEMPRESA    = P_CDEMPRESA
                              AND N.CDINSCESTA   = P_CDINSCESTA
                              AND N.DTENTRSAID   BETWEEN P_DTINICIAL AND P_DTFINAL
                              AND N.IDENTRSAIDOP = 'E'
                              AND N.CDFILIAL     = I.CDFILIAL
                              AND N.NRLANCTONF   = I.NRLANCTONF
                              AND I.CDFISOPEITEM IN ('5124','6124')
                              AND I.CDPRODUTO    = P.CDPRODUTO
                              AND N.IDENTRSAIDOP = T.IDENTRSAIDOP
                              AND N.CDTIPOOPER   = T.CDTIPOOPER
                              AND T.IDNFRETIND   = 'S'
                              AND T.IDENTRSAIDOP = O.IDENTRSAIDOP
                              AND T.CDTIPOOPER   = O.CDTIPOOPER
                              AND O.CDFISCOPER   = I.CDFISOPEITEM
                              AND PF.CDFILIAL    = N.CDFILIRECE
                              AND (O.IDATUESTTPCFOP = 'S' OR
                                   (O.IDENTRSAIDOP, O.CDTIPOOPER, O.CDFISCOPER, I.CDPRODUTO )IN (SELECT IDENTRSAIDOP, CDTIPOOPER, CDFISCOPER, CDPRODUTO
                                                                                                   FROM TPOPERCFOPEXCP))
                            GROUP BY N.DTENTRSAID, DECODE(P_IDCONSPRODEXT, 'S', DECODE(PF.IDUTCDEXTPRONF,'S',NVL(P.CDPRODINTE,P.CDARVPROD),P.CDARVPROD),P.CDARVPROD), N.NRLANCTONF, N.CDFILIAL, N.DTENTRSAID, P.CDPRODUTO, I.CDPRODNCMTRANS, PF.IDUTCDEXTPRONF) LOOP

            SELECT MAX(CDCHAVEREG)
              INTO V_PRODUTO
              FROM TMP_REGDADOSSPED
             WHERE CDCHAVEREG = C_REGK250.CDPRODUTO
               AND CDREGISTRO = '0200';

            IF (C_REGK250.CDPRODUTO IS NOT NULL) THEN
               IF (V_PRODUTO IS NULL) THEN
                  V_SEQUPROD := NVL(V_SEQUPROD,0) + 1;
                  INSERT INTO TMP_REGDADOSSPED
                     (CDREGISTRO, CDCONTREGI, CDCHAVEREG, CDCAMPO1, CDCAMPO3, CDCAMPO4)
                  VALUES
                     ('0200', V_SEQUPROD, C_REGK250.CDPRODUTO, 'S', C_REGK250.CDCLASFISC, C_REGK250.COD_ITEM);
               ELSE
                  UPDATE TMP_REGDADOSSPED
                     SET CDCAMPO1   = 'S'
                   WHERE CDCHAVEREG = C_REGK250.CDPRODUTO
                     AND CDREGISTRO = '0200';
               END IF;
            END IF;

            V_CONTREGK := NVL(V_CONTREGK,0) + 1;
            INSERT INTO ARQMAGNETICO
               (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
            VALUES
               ('75'||LPAD(RTRIM(V_CONTREGK), 8, '0'), C_REGK250.ARQ_K250, P_NRSEQARQMAG);

            IF P_GERABLOCOK <> 'P' THEN
               FOR C_REGK255 IN (SELECT '|K255'                                          ||'|'||
                                        NVL(TO_CHAR(C_REGK250.DTENTRSAID,'DDMMYYYY'),'') ||'|'||
                                        DECODE(P_IDCONSPRODEXT, 'S', DECODE(C_REGK250.IDUTCDEXTPRONF,'S',NVL(P.CDPRODINTE,P.CDARVPROD),P.CDARVPROD),P.CDARVPROD)||'|'||
                                        REPLACE(LTRIM(TO_CHAR(NVL(SUM(ROUND(I.QTITEMPROD,6)),0), '999999999990.000000')), '.', ',') ||'|' ||
                                        '' ||'|' AS ARQ_K255, P.CDPRODUTO, I.CDPRODNCMTRANS AS CDCLASFISC,
                                        DECODE(P_IDCONSPRODEXT, 'S', DECODE(C_REGK250.IDUTCDEXTPRONF,'S',NVL(P.CDPRODINTE,P.CDARVPROD),P.CDARVPROD),P.CDARVPROD) AS COD_ITEM
                                   FROM ITEMPRODUTO I, PRODUTO P
                                  WHERE I.CDFILIAL     = C_REGK250.CDFILIAL
                                    AND I.NRLANCTONF   = C_REGK250.NRLANCTONF
                                    AND I.CDFISOPEITEM IN ('5902','6902')
                                    AND I.CDPRODUTO    = P.CDPRODUTO
                                  GROUP BY DECODE(P_IDCONSPRODEXT, 'S', DECODE(C_REGK250.IDUTCDEXTPRONF,'S',NVL(P.CDPRODINTE,P.CDARVPROD),P.CDARVPROD),P.CDARVPROD), P.CDPRODUTO, I.CDPRODNCMTRANS) LOOP

                  SELECT MAX(CDCHAVEREG)
                    INTO V_PRODUTO
                    FROM TMP_REGDADOSSPED
                   WHERE CDCHAVEREG = C_REGK255.CDPRODUTO
                     AND CDREGISTRO = '0200';

                  IF (V_PRODUTO IS NULL) AND (C_REGK255.CDPRODUTO IS NOT NULL) THEN
                     V_SEQUPROD := NVL(V_SEQUPROD,0) + 1;
                     INSERT INTO TMP_REGDADOSSPED
                        (CDREGISTRO, CDCONTREGI, CDCHAVEREG, CDCAMPO3, CDCAMPO4)
                     VALUES
                        ('0200', V_SEQUPROD, C_REGK255.CDPRODUTO, C_REGK255.CDCLASFISC, C_REGK255.COD_ITEM);
                  END IF;

                  V_CONTREGK := NVL(V_CONTREGK,0) + 1;
                  INSERT INTO ARQMAGNETICO
                     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
                  VALUES
                     ('75'||LPAD(RTRIM(V_CONTREGK), 8, '0'), C_REGK255.ARQ_K255, P_NRSEQARQMAG);
               END LOOP;
            END IF;
         END LOOP;
      END IF;

      /*REGISTRO K280: CORREO DE APONTAMENTO  ESTOQUE ESCRITURADO*/
      NOVO_CODIGO_NT('RELAT_MOVIEST_K280',V_SEQUMOVI);
      V_SEQUMOVI := SUBSTR(V_SEQUMOVI,11,10);
      MOVIMENTACAO_ESTOQUE_K280(P_CDEMPRESA, P_CDINSCESTA, P_DTINICIAL, P_DTFINAL, V_SEQUMOVI);

      FOR C_REGK280 IN (SELECT '|K280'          ||'|'||
                               NVL(TO_CHAR(ADD_MONTHS(TO_DATE(P_DTFINAL),-1),'DDMMYYYY'),'') ||'|'||
                               E.CDPRODMOVIEST  ||'|'||
                               CASE WHEN (E.QTLANCTOEST - E.QTTOTALANT) > 0
                                    THEN REPLACE(LTRIM(TO_CHAR(NVL(ROUND((E.QTLANCTOEST - E.QTTOTALANT),3),0), '999999999990.000')), '.', ',')
                                    ELSE '' END ||'|'||
                               CASE WHEN (E.QTLANCTOEST - E.QTTOTALANT) < 0
                                    THEN REPLACE(LTRIM(TO_CHAR(NVL(ROUND(ABS((E.QTLANCTOEST - E.QTTOTALANT)),3),0), '999999999990.000')), '.', ',')
                                    ELSE '' END ||'|'||
                               IND_EST          ||'|' AS ARQ_K280,
                               --REPLACE(REPLACE(REPLACE(REPLACE(E.IDPARTICIPANTE||E.PARTICIPANTE,'.'),'-'),'/'),' ') ||'|'
                               E.CDPRODUTO, E.IDPARTICIPANTE||E.PARTICIPANTE AS PARTICIPANTE,
                               E.CDPRODMOVIEST AS COD_ITEM
                          FROM RELACPRODITGEN R, TIPOITEMBLOCOK T,
                               (SELECT DECODE(P_IDCONSPRODEXT, 'S', DECODE(PF.IDUTCDEXTPRONF,'S',NVL(P.CDPRODINTE,R.CDPRODMOVIEST),R.CDPRODMOVIEST),R.CDPRODMOVIEST) AS CDPRODMOVIEST,
                                       R.CDPRODUTO, SUM(A.QTLANCTOEST) AS QTLANCTOEST, SUM(R.QTTOTALANT) AS QTTOTALANT,
                                       FC.IDPARTICIPANTE, FC.PARTICIPANTE, CASE WHEN NVL(FC.CDALMOXINFO,  'X') <> 'X' THEN '1'
                                                                                WHEN NVL(FC.CDALMOXTERC,  'X') <> 'X' THEN '2'
                                                                                WHEN NVL(FC.CDALMOXARIFE, 'X') <> 'X' THEN '2'
                                                                                ELSE '0' END IND_EST
                                  FROM RELAT_MOVIEST_K280 R, LOTE L, PRODUTO P, PARAMFILIAL PF,
                                       ITLANCTOEST A LEFT JOIN (SELECT A.CDFILIAL, A.CDCLIENTE AS PARTICIPANTE, 'C' AS IDPARTICIPANTE, A.CDALMOXARIFE,
                                                                       A.CDLOCALESTOQ, C.NRINSJURCLIE AS NRINSJUR,
                                                                       A.CDALMOXTERCCLI CDALMOXTERC, A.CDLOCALTERCCLI CDLOCALTERC,
                                                                       A.CDALMOXINFOCLI CDALMOXINFO, A.CDLOCALINFOCLI CDLOCALINFO
                                                                  FROM AGENTETERCECLI A, CLIENTE C
                                                                 WHERE A.CDCLIENTE  = C.CDCLIENTE
                                                                 UNION
                                                                SELECT A.CDFILIAL, A.CDFORNECED AS PARTICIPANTE, 'F' AS IDPARTICIPANTE, A.CDALMOXARIFE,
                                                                       A.CDLOCALESTOQ, C.NRINSJURFORN AS NRINSJUR,
                                                                       A.CDALMOXTERCFOR CDALMOXTERC, A.CDLOCALTERCFOR CDLOCALTERC,
                                                                       A.CDALMOXINFOFOR CDALMOXINFO, A.CDLOCALINFOFOR CDLOCALINFO
                                                                  FROM AGENTETERCEFOR A, FORNECEDOR C
                                                                 WHERE A.CDFORNECED = C.CDFORNECED) FC ON (FC.CDFILIAL       = A.CDFILIAL AND
                                                                                                          ((FC.CDALMOXARIFE = A.CDALMOXARIFE AND
                                                                                                            FC.CDLOCALESTOQ = A.CDLOCALESTOQ) OR
                                                                                                           (FC.CDALMOXTERC  = A.CDALMOXARIFE AND
                                                                                                            FC.CDLOCALTERC  = A.CDLOCALESTOQ) OR
                                                                                                           (FC.CDALMOXINFO  = A.CDALMOXARIFE AND
                                                                                                            FC.CDLOCALINFO  = A.CDLOCALESTOQ)))
                                 WHERE R.NRRELATMOVI  = V_SEQUMOVI
                                   AND A.CDFILIAL     = R.CDFILLANCMEST
                                   AND A.CDFILIMOVI   = R.CDFILIMOVIEST
                                   AND A.NRLANCESTQ   = R.NRLANCMOVIEST
                                   AND A.NRSEQUITEM   = R.NRSEQUMOVIEST
                                   AND A.CDALMOXARIFE = R.CDALMOXARIRM
                                   AND A.CDLOCALESTOQ = R.CDLOCALESTRM
                                   AND A.IDTIPOMOVI   = R.IDTIPOMOVIEST
                                   AND A.IDTIPOMOVI   = '1'
                                   AND A.CDFILIMOVI   = L.CDFILIAL
                                   AND A.NRLOTEESTQ   = L.NRLOTEESTQ
                                   AND A.NRSUBLOTE    = L.NRSUBLOTE
                                   AND A.CDPRODMOVI   = L.CDPRODUTO
                                   AND ABS(ROUND(A.QTLANCTOEST - R.QTTOTALANT,3)) > 0
                                   AND R.CDPRODUTO    = P.CDPRODUTO
                                   AND PF.CDFILIAL    = A.CDFILIAL
                                 GROUP BY DECODE(P_IDCONSPRODEXT, 'S', DECODE(PF.IDUTCDEXTPRONF,'S',NVL(P.CDPRODINTE,R.CDPRODMOVIEST),R.CDPRODMOVIEST),R.CDPRODMOVIEST), R.CDPRODUTO, FC.IDPARTICIPANTE, FC.PARTICIPANTE,
                                       CASE WHEN NVL(FC.CDALMOXINFO,  'X') <> 'X' THEN '1'
                                            WHEN NVL(FC.CDALMOXTERC,  'X') <> 'X' THEN '2'
                                            WHEN NVL(FC.CDALMOXARIFE, 'X') <> 'X' THEN '2'
                                            ELSE '0' END)E
                         WHERE R.CDPRODUTO     = E.CDPRODUTO
                           AND R.CDLIVROMAG    = P_LIVROMAG
                           AND R.CDTPITEMPROD  = T.CDTPITEMPROD
                           AND T.IDITEMESTOQUE = 'S'
                           AND ABS(E.QTLANCTOEST - E.QTTOTALANT) > 0) LOOP 

         V_PARTICIPANTE := '';
         /* CODIGO DO PARTICIPANTE */
         SELECT MAX(CDCHAVEREG)
           INTO V_COD_PAR
           FROM TMP_REGDADOSSPED
          WHERE CDCHAVEREG = C_REGK280.PARTICIPANTE
            AND CDREGISTRO = '0150';

         IF (V_COD_PAR IS NULL) AND (C_REGK280.PARTICIPANTE IS NOT NULL) THEN
            V_PARTICIPANTE := RETORNA_PARTICIPANTE_SPED(C_REGK280.PARTICIPANTE);
            IF V_PARTICIPANTE IS NULL THEN
               V_SEQUPROD := NVL(V_SEQUPROD,0) + 1;
               INSERT INTO TMP_REGDADOSSPED
                 (CDREGISTRO, CDCONTREGI, CDCHAVEREG)
               VALUES
                 ('0150', V_SEQUPROD, C_REGK280.PARTICIPANTE);
            END IF;
         END IF;

         V_PARTICIPANTE := REPLACE(REPLACE(REPLACE(REPLACE(NVL(V_PARTICIPANTE,C_REGK280.PARTICIPANTE),'.'),'-'),'/'),' ')||'|';

         /*CDIGO DO PRODUTO*/
         SELECT MAX(CDCHAVEREG)
           INTO V_PRODUTO
           FROM TMP_REGDADOSSPED
          WHERE CDCHAVEREG = C_REGK280.CDPRODUTO
            AND CDREGISTRO = '0200';

         IF (V_PRODUTO IS NULL) AND (C_REGK280.CDPRODUTO IS NOT NULL) THEN
            V_SEQUPROD := NVL(V_SEQUPROD,0) + 1;
            INSERT INTO TMP_REGDADOSSPED
               (CDREGISTRO, CDCONTREGI, CDCHAVEREG, CDCAMPO4)
            VALUES
               ('0200', V_SEQUPROD, C_REGK280.CDPRODUTO, C_REGK280.COD_ITEM);
         END IF;

         /*UNIDADE DE MEDIDA */
         BEGIN
            SELECT SGUNIDADE
              INTO V_SGUNIDADE
              FROM PRODUTO
             WHERE CDPRODUTO = C_REGK280.CDPRODUTO;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_SGUNIDADE := NULL;
         END;

         SELECT MAX(CDCHAVEREG)
           INTO V_UNID
           FROM TMP_REGDADOSSPED
          WHERE CDCHAVEREG = V_SGUNIDADE
            AND CDREGISTRO = '0190';

         IF (V_UNID IS NULL) AND (V_SGUNIDADE IS NOT NULL) THEN
             V_SEQUPROD := NVL(V_SEQUPROD,0) + 1;
             INSERT INTO TMP_REGDADOSSPED
               (CDREGISTRO, CDCONTREGI, CDCHAVEREG)
             VALUES
               ('0190', V_SEQUPROD, V_SGUNIDADE);
         END IF;
         V_UNID := NULL;

         V_CONTREGK := NVL(V_CONTREGK,0) + 1;
         INSERT INTO ARQMAGNETICO
            (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
            ('75'||LPAD(RTRIM(V_CONTREGK), 8, '0'), C_REGK280.ARQ_K280||V_PARTICIPANTE, P_NRSEQARQMAG);
      END LOOP;
   END IF;

   IF P_DTINICIAL >= '01/01/2016' THEN
      IF V_CONTREGK <> 0 THEN
         V_MOVIMENT := 0;
      ELSE
         V_MOVIMENT := 1;
      END IF;

      /* ABERTURA DO REGISTRO K */
      V_CONTREGK := NVL(V_CONTREGK,0) + 1;
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        ('75'||LPAD('0', 8, '0'), '|K001'|| '|' ||V_MOVIMENT|| '|', P_NRSEQARQMAG);

      IF (TO_NUMBER(P_VERSAO) >= 17) AND (V_MOVIMENT = 0) AND (P_GERABLOCOK IN ('S','E','P')) THEN 

         /* ABERTURA DO REGISTRO K */
         V_CONTREGK := NVL(V_CONTREGK,0) + 1;
         INSERT INTO ARQMAGNETICO
           (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
           ('75'||LPAD('0', 8, '0'), '|K010'|| '|' ||DECODE(P_GERABLOCOK,'P',0,'S',1,'E',2)|| '|', P_NRSEQARQMAG);
      END IF;

      /* ENCERRAMENTO DO BLOCO K */
      V_CONTREGK := NVL(V_CONTREGK,0) + 1;
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        ('79'||LPAD(RTRIM(V_CONTREGK), 8, '0'), '|K990'|| '|' ||V_CONTREGK|| '|', P_NRSEQARQMAG);
   END IF;

   RETURN(LPAD(TO_CHAR(NVL(V_CONTREGK,0)),10, '0')||LPAD(TO_CHAR(NVL(V_SEQUPROD,0)),10,'0'));
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('SPED_BLOCOK','6.49.077'); END;
/
