



-- #############################################################################
-- #############################################################################
-- #############################################################################
-- ############### APETECE Migrar servios de dieta para normal ################
-- #############################################################################
-- #############################################################################
-- #############################################################################

-- #############################################################################
-- ############################ Consultas auxiliares ###########################
-- #############################################################################

SELECT CDFILIAL, CDSERVFILI, DTCARDAPIO, CDDIETPAD, LENGTH(CDDIETPAD) TAM_DIETA FROM
(
SELECT C.CDFILIAL, C.CDSERVFILI, C.DTCARDAPIO,
       LISTAGG(C.NRCARDAPIO||
               ' '||NVL(C.CDDIETPAD,'NULL')||
               ' R ='||TO_CHAR(NVL(R.QTRETIRADAS, 0), '00')||
               ' P ='||TO_CHAR(NVL(P.QTPRATOS, 0), '00'), ', ') WITHIN GROUP (ORDER BY C.NRCARDAPIO, C.CDDIETPAD) CDDIETPAD
  FROM CARDADIA C
 INNER JOIN SERVICO S
    ON S.CDFILIAL = C.CDFILIAL
   AND S.CDSERVFILI = C.CDSERVFILI
   AND S.IDTIPOSERV = 'D'
   LEFT JOIN (SELECT CDFILIAL, NRCARDAPIO, COUNT(*) QTRETIRADAS FROM RETIRADA GROUP BY CDFILIAL, NRCARDAPIO) R
    ON R.CDFILIAL = C.CDFILIAL
   AND R.NRCARDAPIO = C.NRCARDAPIO
  LEFT JOIN (SELECT CDFILIAL, NRCARDAPIO, COUNT(*) QTPRATOS FROM COMPCARD GROUP BY CDFILIAL, NRCARDAPIO) P
    ON P.CDFILIAL = C.CDFILIAL
   AND P.NRCARDAPIO = C.NRCARDAPIO
GROUP BY C.CDFILIAL, C.CDSERVFILI, C.DTCARDAPIO
 ORDER BY C.CDFILIAL, C.CDSERVFILI, C.DTCARDAPIO
)
 ORDER BY CDFILIAL, CDSERVFILI, DTCARDAPIO
/

SELECT C.DTCARDAPIO, C.CDFILIAL, C.CDSERVFILI, C.NRCARDAPIO, NVL(C.CDDIETPAD,'NULL'), R.QTRETIRADAS, P.QTPRATOS
  FROM CARDADIA C
 INNER JOIN SERVICO S
    ON S.CDFILIAL = C.CDFILIAL
   AND S.CDSERVFILI = C.CDSERVFILI
   AND S.IDTIPOSERV = 'D'
  LEFT JOIN (SELECT CDFILIAL, NRCARDAPIO, COUNT(*) QTRETIRADAS FROM RETIRADA GROUP BY CDFILIAL, NRCARDAPIO) R
    ON R.CDFILIAL = C.CDFILIAL
   AND R.NRCARDAPIO = C.NRCARDAPIO
  LEFT JOIN (SELECT CDFILIAL, NRCARDAPIO, COUNT(*) QTPRATOS FROM COMPCARD GROUP BY CDFILIAL, NRCARDAPIO) P
    ON P.CDFILIAL = C.CDFILIAL
   AND P.NRCARDAPIO = C.NRCARDAPIO
 ORDER BY C.DTCARDAPIO, C.CDFILIAL, C.CDSERVFILI, C.CDDIETPAD
/

SELECT C.*
  FROM CARDADIA C
 INNER JOIN SERVICO S
    ON S.CDFILIAL = C.CDFILIAL
   AND S.CDSERVFILI = C.CDSERVFILI
   AND S.IDTIPOSERV = 'D'
/

SELECT CA.*
  FROM CARDADIA CA
 INNER JOIN SERVICO S
    ON S.CDFILIAL = CA.CDFILIAL
   AND S.CDSERVFILI = CA.CDSERVFILI
   AND S.IDTIPOSERV = 'D'
 INNER JOIN COMPCARD CO
    ON CO.CDFILIAL = CA.CDFILIAL
   AND CO.NRCARDAPIO = CA.NRCARDAPIO
/

SELECT *
  FROM SERVICO
 WHERE IDTIPOSERV = 'D'
/

SELECT COUNT(*)
  FROM TMP_CARDADIA_BKP_DIET
/

SELECT COUNT(*)
  FROM TMP_COMPCARD_BKP_DIET
/

-- #############################################################################
-- #############################################################################
-- ########################## Comandos para migrao ###########################
-- #############################################################################
-- #############################################################################
-- #############################################################################

-- CRIA CAMPO DE BACKUP DO IDENTIFICADOR DE TIPO DE SERVIO QUE POSTERIORMENTE
-- SER ALTERADO DE 'D' (DIETA) PARA 'N' (NORMAL)
ALTER TABLE SERVICO ADD TMP_IDTIPOSERV_BKP VARCHAR2(1)
/

-- PREENCHE O CAMPO DE BACKUP DO IDENTIFICADOR DE TIPO DE SERVIO COM O VALOR ORIGINAL
UPDATE SERVICO SET TMP_IDTIPOSERV_BKP = IDTIPOSERV WHERE TMP_IDTIPOSERV_BKP IS NULL
/

COMMIT
/


-- PREENCHE OS CAMPOS DE COMENSAIS PADROES POR DIA DA SEMANA DOS SERVICOS COM A MESMA INFORMAO QUE EXISTIA POR DIETA
DECLARE
   L_QTCOMDIETSEG FLOAT;
   L_QTCOMDIETTER FLOAT;
   L_QTCOMDIETQUA FLOAT;
   L_QTCOMDIETQUI FLOAT;
   L_QTCOMDIETSEX FLOAT;
   L_QTCOMDIETSAB FLOAT;
   L_QTCOMDIETDOM FLOAT;
   L_QTCOMDIETFER FLOAT;
   L_QTCLIDIETSEG FLOAT;
   L_QTCLIDIETTER FLOAT;
   L_QTCLIDIETQUA FLOAT;
   L_QTCLIDIETQUI FLOAT;
   L_QTCLIDIETSEX FLOAT;
   L_QTCLIDIETSAB FLOAT;
   L_QTCLIDIETDOM FLOAT;
   L_QTCLIDIETFER FLOAT;
   L_QTFUNDIETSEG FLOAT;
   L_QTFUNDIETTER FLOAT;
   L_QTFUNDIETQUA FLOAT;
   L_QTFUNDIETQUI FLOAT;
   L_QTFUNDIETSEX FLOAT;
   L_QTFUNDIETSAB FLOAT;
   L_QTFUNDIETDOM FLOAT;
   L_QTFUNDIETFER FLOAT;
   L_QTDOADIETSEG FLOAT;
   L_QTDOADIETTER FLOAT;
   L_QTDOADIETQUA FLOAT;
   L_QTDOADIETQUI FLOAT;
   L_QTDOADIETSEX FLOAT;
   L_QTDOADIETSAB FLOAT;
   L_QTDOADIETDOM FLOAT;
   L_QTDOADIETFER FLOAT;
BEGIN
   FOR C_SERV IN (SELECT CDFILIAL, CDSERVFILI
                    FROM SERVICO S
                   WHERE S.TMP_IDTIPOSERV_BKP = 'D') LOOP
      SELECT SUM(NVL(QTCOMDIETSEG, 0)), SUM(NVL(QTCOMDIETTER, 0)), SUM(NVL(QTCOMDIETQUA, 0)),
             SUM(NVL(QTCOMDIETQUI, 0)), SUM(NVL(QTCOMDIETSEX, 0)), SUM(NVL(QTCOMDIETSAB, 0)),
             SUM(NVL(QTCOMDIETDOM, 0)), SUM(NVL(QTCOMDIETFER, 0)), SUM(NVL(QTCLIDIETSEG, 0)),
             SUM(NVL(QTCLIDIETTER, 0)), SUM(NVL(QTCLIDIETQUA, 0)), SUM(NVL(QTCLIDIETQUI, 0)),
             SUM(NVL(QTCLIDIETSEX, 0)), SUM(NVL(QTCLIDIETSAB, 0)), SUM(NVL(QTCLIDIETDOM, 0)),
             SUM(NVL(QTCLIDIETFER, 0)), SUM(NVL(QTFUNDIETSEG, 0)), SUM(NVL(QTFUNDIETTER, 0)),
             SUM(NVL(QTFUNDIETQUA, 0)), SUM(NVL(QTFUNDIETQUI, 0)), SUM(NVL(QTFUNDIETSEX, 0)),
             SUM(NVL(QTFUNDIETSAB, 0)), SUM(NVL(QTFUNDIETDOM, 0)), SUM(NVL(QTFUNDIETFER, 0)),
             SUM(NVL(QTDOADIETSEG, 0)), SUM(NVL(QTDOADIETTER, 0)), SUM(NVL(QTDOADIETQUA, 0)),
             SUM(NVL(QTDOADIETQUI, 0)), SUM(NVL(QTDOADIETSEX, 0)), SUM(NVL(QTDOADIETSAB, 0)),
             SUM(NVL(QTDOADIETDOM, 0)), SUM(NVL(QTDOADIETFER, 0))
        INTO L_QTCOMDIETSEG, L_QTCOMDIETTER, L_QTCOMDIETQUA,
             L_QTCOMDIETQUI, L_QTCOMDIETSEX, L_QTCOMDIETSAB,
             L_QTCOMDIETDOM, L_QTCOMDIETFER, L_QTCLIDIETSEG,
             L_QTCLIDIETTER, L_QTCLIDIETQUA, L_QTCLIDIETQUI,
             L_QTCLIDIETSEX, L_QTCLIDIETSAB, L_QTCLIDIETDOM,
             L_QTCLIDIETFER, L_QTFUNDIETSEG, L_QTFUNDIETTER,
             L_QTFUNDIETQUA, L_QTFUNDIETQUI, L_QTFUNDIETSEX,
             L_QTFUNDIETSAB, L_QTFUNDIETDOM, L_QTFUNDIETFER,
             L_QTDOADIETSEG, L_QTDOADIETTER, L_QTDOADIETQUA,
             L_QTDOADIETQUI, L_QTDOADIETSEX, L_QTDOADIETSAB,
             L_QTDOADIETDOM, L_QTDOADIETFER
        FROM DIETSERV D
       WHERE D.CDFILIAL = C_SERV.CDFILIAL
         AND D.CDSERVFILI = C_SERV.CDSERVFILI;
      UPDATE SERVICO 
         SET QTCOMESTISEG = L_QTCOMDIETSEG, QTCOMESTITER = L_QTCOMDIETTER, QTCOMESTIQUA = L_QTCOMDIETQUA,
             QTCOMESTIQUI = L_QTCOMDIETQUI, QTCOMESTISEX = L_QTCOMDIETSEX, QTCOMESTISAB = L_QTCOMDIETSAB,
             QTCOMESTIDOM = L_QTCOMDIETDOM, QTCOMESTIFER = L_QTCOMDIETFER, QTCLIESTISEG = L_QTCLIDIETSEG,
             QTCLIESTITER = L_QTCLIDIETTER, QTCLIESTIQUA = L_QTCLIDIETQUA, QTCLIESTIQUI = L_QTCLIDIETQUI,
             QTCLIESTISEX = L_QTCLIDIETSEX, QTCLIESTISAB = L_QTCLIDIETSAB, QTCLIESTIDOM = L_QTCLIDIETDOM,
             QTCLIESTIFER = L_QTCLIDIETFER, QTFUNESTISEG = L_QTFUNDIETSEG, QTFUNESTITER = L_QTFUNDIETTER,
             QTFUNESTIQUA = L_QTFUNDIETQUA, QTFUNESTIQUI = L_QTFUNDIETQUI, QTFUNESTISEX = L_QTFUNDIETSEX,
             QTFUNESTISAB = L_QTFUNDIETSAB, QTFUNESTIDOM = L_QTFUNDIETDOM, QTFUNESTIFER = L_QTFUNDIETFER,
             QTDOAESTISEG = L_QTDOADIETSEG, QTDOAESTITER = L_QTDOADIETTER, QTDOAESTIQUA = L_QTDOADIETQUA,
             QTDOAESTIQUI = L_QTDOADIETQUI, QTDOAESTISEX = L_QTDOADIETSEX, QTDOAESTISAB = L_QTDOADIETSAB,
             QTDOAESTIDOM = L_QTDOADIETDOM, QTDOAESTIFER = L_QTDOADIETFER
       WHERE CDFILIAL = C_SERV.CDFILIAL
         AND CDSERVFILI = C_SERV.CDSERVFILI;
      COMMIT;
   END LOOP;
END;
/

-- CRIA TABELA DE BACKUP DA CARDADIA
CREATE TABLE TMP_CARDADIA_BKP_DIET AS SELECT * FROM CARDADIA WHERE 1 = 2
/

CREATE INDEX TMP_CARDADIA_BKP_DIET_01 ON TMP_CARDADIA_BKP_DIET (CDFILIAL, NRCARDAPIO)
/

-- CRIA TABELA DE BACKUP DA COMPCARD
CREATE TABLE TMP_COMPCARD_BKP_DIET AS SELECT * FROM COMPCARD WHERE 1 = 2
/

CREATE INDEX TMP_COMPCARD_BKP_DIET_01 ON TMP_COMPCARD_BKP_DIET (CDFILIAL, NRCARDAPIO)
/

-- PREENCHE AS TABELAS DE BACKUP COM REGISTROS DA CARDADIA DOS SERVIOS COM IDTIPOSERV = 'D' (DIETA)
-- E SEUS RESPECTIVOS REGISTROS NA COMPCARD
DECLARE
   V_COUNT NUMBER;
BEGIN
   V_COUNT := 0;
   FOR C_CARD IN (SELECT C.*
                    FROM CARDADIA C
                   INNER JOIN SERVICO S
                      ON S.CDFILIAL = C.CDFILIAL
                     AND S.CDSERVFILI = C.CDSERVFILI
                     AND S.IDTIPOSERV = 'D'
                     AND NOT EXISTS (SELECT *
                                       FROM TMP_CARDADIA_BKP_DIET T
                                      WHERE T.CDFILIAL = C.CDFILIAL
                                        AND T.NRCARDAPIO = C.NRCARDAPIO)) LOOP
      INSERT INTO TMP_CARDADIA_BKP_DIET
         (CDFILIAL, NRCARDAPIO, CDSERVFILI, CDOPERADOR, DTCARDAPIO, QTCOMESTICAR,
          QTESTITURNO1, QTESTITURNO2, QTESTITURNO3, QTESTITURNO4, QTCLIESTICAR, QTFUNESTICAR,
          QTDOAESTICAR, QTCOMEFETCAR, QTCLIEFETCAR, QTFUNEFETCAR, QTDOAEFETCAR, IDEFETINFO,
          DTULTATUACAR, VRPESPORPERC, IDFOLLOWUPRI, IDFOLLOWUPSL, QTCOMEFETRI, IDEFETINFORI,
          QTCOMEFETSL, IDEFETINFOSL, CDFILAUXPRRI, CDMAIORPRERI, CDFILAUXPRSL, CDMAIORPRESL,
          IDCADMANPRED, QTSOBRLIMPCA, QTRESTINGECA, DTMESCARD, CDDIETPAD, DSCARDAPIO,
          DTREFECUST, IDCARDIAESPE, IDCARDLIBCEN, IDCARDLIBAGR, DSRDMUSUCARD, DSENDUSUCARD,
          DSNMUSUCARD, DSMETUSUCARD, CDORESPCARD, VRPESPORPERCRI, NRORG, DTINCLUSAO,
          DTULTATU, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU, IDATIVO)
      VALUES
         (C_CARD.CDFILIAL, C_CARD.NRCARDAPIO, C_CARD.CDSERVFILI, C_CARD.CDOPERADOR, C_CARD.DTCARDAPIO, C_CARD.QTCOMESTICAR,
          C_CARD.QTESTITURNO1, C_CARD.QTESTITURNO2, C_CARD.QTESTITURNO3, C_CARD.QTESTITURNO4, C_CARD.QTCLIESTICAR, C_CARD.QTFUNESTICAR,
          C_CARD.QTDOAESTICAR, C_CARD.QTCOMEFETCAR, C_CARD.QTCLIEFETCAR, C_CARD.QTFUNEFETCAR, C_CARD.QTDOAEFETCAR, C_CARD.IDEFETINFO,
          C_CARD.DTULTATUACAR, C_CARD.VRPESPORPERC, C_CARD.IDFOLLOWUPRI, C_CARD.IDFOLLOWUPSL, C_CARD.QTCOMEFETRI, C_CARD.IDEFETINFORI,
          C_CARD.QTCOMEFETSL, C_CARD.IDEFETINFOSL, C_CARD.CDFILAUXPRRI, C_CARD.CDMAIORPRERI, C_CARD.CDFILAUXPRSL, C_CARD.CDMAIORPRESL,
          C_CARD.IDCADMANPRED, C_CARD.QTSOBRLIMPCA, C_CARD.QTRESTINGECA, C_CARD.DTMESCARD, C_CARD.CDDIETPAD, C_CARD.DSCARDAPIO,
          C_CARD.DTREFECUST, C_CARD.IDCARDIAESPE, C_CARD.IDCARDLIBCEN, C_CARD.IDCARDLIBAGR, C_CARD.DSRDMUSUCARD, C_CARD.DSENDUSUCARD,
          C_CARD.DSNMUSUCARD, C_CARD.DSMETUSUCARD, C_CARD.CDORESPCARD, C_CARD.VRPESPORPERCRI, C_CARD.NRORG, C_CARD.DTINCLUSAO,
          C_CARD.DTULTATU, C_CARD.NRORGINCLUSAO, C_CARD.CDOPERINCLUSAO, C_CARD.NRORGULTATU, C_CARD.CDOPERULTATU, C_CARD.IDATIVO);

      FOR C_COMP IN (SELECT *
                       FROM COMPCARD
                      WHERE CDFILIAL = C_CARD.CDFILIAL
                        AND NRCARDAPIO = C_CARD.NRCARDAPIO) LOOP
         INSERT INTO TMP_COMPCARD_BKP_DIET
            (CDFILIAL, NRCARDAPIO, NRSEQPRATCAR, CDFILAUXPRAT, CDPRATO,
             VRPECONSCARD, QTSOBRLIMPPR, CDTIPOPRAT, QTCOMEFETPRA, QTPRODUZPRAT,
             NRORDPRATCAR, IDPRATOESPE, CDFILAUXPRATMAT, CDPRATOMAT, CDOPERALTE,
             DTCOMPCARDALT, NRORG, DTINCLUSAO, DTULTATU,
             NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU, IDATIVO)
         VALUES
            (C_COMP.CDFILIAL, C_COMP.NRCARDAPIO, C_COMP.NRSEQPRATCAR, C_COMP.CDFILAUXPRAT, C_COMP.CDPRATO,
             C_COMP.VRPECONSCARD, C_COMP.QTSOBRLIMPPR, C_COMP.CDTIPOPRAT, C_COMP.QTCOMEFETPRA, C_COMP.QTPRODUZPRAT,
             C_COMP.NRORDPRATCAR, C_COMP.IDPRATOESPE, C_COMP.CDFILAUXPRATMAT, C_COMP.CDPRATOMAT, C_COMP.CDOPERALTE,
             C_COMP.DTCOMPCARDALT, C_COMP.NRORG, C_COMP.DTINCLUSAO, C_COMP.DTULTATU,
             C_COMP.NRORGINCLUSAO, C_COMP.CDOPERINCLUSAO, C_COMP.NRORGULTATU, C_COMP.CDOPERULTATU, C_COMP.IDATIVO);
      END LOOP;

      IF V_COUNT > 1000 THEN
         V_COUNT := 0;
         COMMIT;
      ELSE
         V_COUNT := V_COUNT + 1;
      END IF;
   END LOOP;
   COMMIT;
END;
/

-- CRIA IDENTIFICADOR QUE INDICAR CARDPIOS DUPLICADOS
ALTER TABLE CARDADIA ADD TMP_IDCARDAPIO_DUPLICADO VARCHAR2(1)
/

-- PREENCHE OS CARDPIOS DUPLICADOS PARA POSTERIORMENTE UM DELES SER EXCLUDO
BEGIN
   FOR C_CARD IN (SELECT *
                    FROM (
                          SELECT SUM(1) OVER (PARTITION BY C.DTCARDAPIO, C.CDFILIAL, C.CDSERVFILI
                                                  ORDER BY C.DTCARDAPIO, C.CDFILIAL, C.CDSERVFILI
                                              ROWS BETWEEN UNBOUNDED PRECEDING AND CURRENT ROW) NRCARDAPIOSERVDIA,
                                 C.DTCARDAPIO, C.CDFILIAL, C.CDSERVFILI,
                                 C.NRCARDAPIO, NVL(C.CDDIETPAD,'NULL'), NVL(R.QTRETIRADAS, 0) QTRETIRADAS, NVL(P.QTPRATOS, 0) QTPRATOS
                            FROM CARDADIA C
                           INNER JOIN SERVICO S
                              ON S.CDFILIAL = C.CDFILIAL
                             AND S.CDSERVFILI = C.CDSERVFILI
                             AND S.IDTIPOSERV = 'D'
                            LEFT JOIN (SELECT CDFILIAL, NRCARDAPIO, NVL(COUNT(*),0) QTRETIRADAS
                                         FROM RETIRADA
                                        GROUP BY CDFILIAL, NRCARDAPIO) R
                              ON R.CDFILIAL = C.CDFILIAL
                             AND R.NRCARDAPIO = C.NRCARDAPIO
                            LEFT JOIN (SELECT CDFILIAL, NRCARDAPIO, NVL(COUNT(*),0) QTPRATOS
                                         FROM COMPCARD
                                        GROUP BY CDFILIAL, NRCARDAPIO) P
                              ON P.CDFILIAL = C.CDFILIAL
                             AND P.NRCARDAPIO = C.NRCARDAPIO
                           ORDER BY C.DTCARDAPIO, C.CDFILIAL, C.CDSERVFILI, C.CDDIETPAD
                          )
                   WHERE NRCARDAPIOSERVDIA >= 2
                  ) LOOP
      UPDATE CARDADIA
         SET TMP_IDCARDAPIO_DUPLICADO = 'S'
       WHERE CDFILIAL = C_CARD.CDFILIAL
         AND CDSERVFILI = C_CARD.CDSERVFILI
         AND DTCARDAPIO = C_CARD.DTCARDAPIO;
      COMMIT;
   END LOOP;
END;
/

-- APAGA DUPLICADOS QUE TEM TODOS OS CAMPOS ZERADOS
-- DEIXANDO SOMENTE UM
BEGIN
   FOR C_CARD IN (SELECT *
                    FROM (
                          SELECT SUM(1) OVER (PARTITION BY C.DTCARDAPIO, C.CDFILIAL, C.CDSERVFILI
                                                  ORDER BY C.DTCARDAPIO, C.CDFILIAL, C.CDSERVFILI
                                              ROWS BETWEEN UNBOUNDED PRECEDING AND CURRENT ROW) NRCARDAPIOSERVDIA,
                                 C.DTCARDAPIO, C.CDFILIAL, C.CDSERVFILI,
                                 C.NRCARDAPIO, NVL(C.CDDIETPAD,'NULL'), NVL(R.QTRETIRADAS, 0) QTRETIRADAS, NVL(P.QTPRATOS, 0) QTPRATOS,
                                 QTCOMESTICAR, QTCLIESTICAR, QTFUNESTICAR, QTDOAESTICAR,
                                 QTCOMEFETCAR, QTCLIEFETCAR, QTFUNEFETCAR, QTDOAEFETCAR,
                                 QTESTITURNO1, QTESTITURNO2, QTESTITURNO3, QTESTITURNO4,
                                 IDEFETINFO, VRPESPORPERC, IDFOLLOWUPRI, IDFOLLOWUPSL,
                                 QTCOMEFETRI, IDEFETINFORI, QTCOMEFETSL, IDEFETINFOSL,
                                 CDFILAUXPRRI, CDMAIORPRERI, CDFILAUXPRSL, CDMAIORPRESL,
                                 IDCADMANPRED, QTSOBRLIMPCA, QTRESTINGECA, DSCARDAPIO,
                                 DTREFECUST, IDCARDIAESPE, IDCARDLIBCEN, IDCARDLIBAGR,
                                 DSRDMUSUCARD, DSENDUSUCARD, DSNMUSUCARD, DSMETUSUCARD,
                                 CDORESPCARD, VRPESPORPERCRI
                            FROM CARDADIA C
                           INNER JOIN SERVICO S
                              ON S.CDFILIAL = C.CDFILIAL
                             AND S.CDSERVFILI = C.CDSERVFILI
                             AND S.IDTIPOSERV = 'D'
                            LEFT JOIN (SELECT CDFILIAL, NRCARDAPIO, NVL(COUNT(*),0) QTRETIRADAS
                                         FROM RETIRADA
                                        GROUP BY CDFILIAL, NRCARDAPIO) R
                              ON R.CDFILIAL = C.CDFILIAL
                             AND R.NRCARDAPIO = C.NRCARDAPIO
                            LEFT JOIN (SELECT CDFILIAL, NRCARDAPIO, NVL(COUNT(*),0) QTPRATOS
                                         FROM COMPCARD
                                        GROUP BY CDFILIAL, NRCARDAPIO) P
                              ON P.CDFILIAL = C.CDFILIAL
                             AND P.NRCARDAPIO = C.NRCARDAPIO
                           WHERE TMP_IDCARDAPIO_DUPLICADO = 'S'
                           ORDER BY C.DTCARDAPIO, C.CDFILIAL, C.CDSERVFILI, C.CDDIETPAD
                           )
                   WHERE QTRETIRADAS = 0
                     AND QTPRATOS = 0
                     AND NVL(QTCOMESTICAR, 0) = 0
                     AND NVL(QTCOMEFETCAR, 0) = 0
                  ) LOOP
      DELETE CARDADIA
       WHERE CDFILIAL = C_CARD.CDFILIAL
         AND NRCARDAPIO = C_CARD.NRCARDAPIO;
      COMMIT;
      UPDATE CARDADIA
         SET TMP_IDCARDAPIO_DUPLICADO = NULL,
             CDDIETPAD = NULL
       WHERE CDFILIAL = C_CARD.CDFILIAL
         AND CDSERVFILI = C_CARD.CDSERVFILI
         AND DTCARDAPIO = C_CARD.DTCARDAPIO;
      COMMIT;
   END LOOP;
END;
/

-- MOVE OS PRATOS PARA OS CARDAPIOS QUE POSSUEM RETIRADAS
-- E APAGA OS CARDAPIOS QUE NO POSSUEM
DECLARE
   V_NRCARDAPIO_PLA CARDADIA.NRCARDAPIO%TYPE;
   V_QTCOMESTICAR FLOAT;
   V_QTCLIESTICAR FLOAT;
   V_QTFUNESTICAR FLOAT;
   V_QTDOAESTICAR FLOAT;
   V_QTCOMEFETCAR FLOAT;
   V_QTCLIEFETCAR FLOAT;
   V_QTFUNEFETCAR FLOAT;
   V_QTDOAEFETCAR FLOAT;
   V_QTESTITURNO1 FLOAT;
   V_QTESTITURNO2 FLOAT;
   V_QTESTITURNO3 FLOAT;
   V_QTESTITURNO4 FLOAT;
BEGIN
   FOR C_CARD IN (SELECT *
                    FROM (
                          SELECT SUM(1) OVER (PARTITION BY C.DTCARDAPIO, C.CDFILIAL, C.CDSERVFILI
                                                  ORDER BY C.DTCARDAPIO, C.CDFILIAL, C.CDSERVFILI
                                              ROWS BETWEEN UNBOUNDED PRECEDING AND CURRENT ROW) NRCARDAPIOSERVDIA,
                                 C.DTCARDAPIO, C.CDFILIAL, C.CDSERVFILI,
                                 C.NRCARDAPIO, NVL(C.CDDIETPAD,'NULL'), NVL(R.QTRETIRADAS, 0) QTRETIRADAS, NVL(P.QTPRATOS, 0) QTPRATOS,
                                 QTCOMESTICAR, QTCLIESTICAR, QTFUNESTICAR, QTDOAESTICAR,
                                 QTCOMEFETCAR, QTCLIEFETCAR, QTFUNEFETCAR, QTDOAEFETCAR,
                                 QTESTITURNO1, QTESTITURNO2, QTESTITURNO3, QTESTITURNO4,
                                 IDEFETINFO, VRPESPORPERC, IDFOLLOWUPRI, IDFOLLOWUPSL,
                                 QTCOMEFETRI, IDEFETINFORI, QTCOMEFETSL, IDEFETINFOSL,
                                 CDFILAUXPRRI, CDMAIORPRERI, CDFILAUXPRSL, CDMAIORPRESL,
                                 IDCADMANPRED, QTSOBRLIMPCA, QTRESTINGECA, DSCARDAPIO,
                                 DTREFECUST, IDCARDIAESPE, IDCARDLIBCEN, IDCARDLIBAGR,
                                 DSRDMUSUCARD, DSENDUSUCARD, DSNMUSUCARD, DSMETUSUCARD,
                                 CDORESPCARD, VRPESPORPERCRI
                            FROM CARDADIA C
                           INNER JOIN SERVICO S
                              ON S.CDFILIAL = C.CDFILIAL
                             AND S.CDSERVFILI = C.CDSERVFILI
                             AND S.IDTIPOSERV = 'D'
                            LEFT JOIN (SELECT CDFILIAL, NRCARDAPIO, NVL(COUNT(*),0) QTRETIRADAS
                                         FROM RETIRADA
                                        GROUP BY CDFILIAL, NRCARDAPIO) R
                              ON R.CDFILIAL = C.CDFILIAL
                             AND R.NRCARDAPIO = C.NRCARDAPIO
                            LEFT JOIN (SELECT CDFILIAL, NRCARDAPIO, NVL(COUNT(*),0) QTPRATOS
                                         FROM COMPCARD
                                        GROUP BY CDFILIAL, NRCARDAPIO) P
                              ON P.CDFILIAL = C.CDFILIAL
                             AND P.NRCARDAPIO = C.NRCARDAPIO
                           WHERE TMP_IDCARDAPIO_DUPLICADO = 'S'
                           ORDER BY C.DTCARDAPIO, C.CDFILIAL, C.CDSERVFILI, C.CDDIETPAD
                           )
                   WHERE QTRETIRADAS = 1
                  ) LOOP

      SELECT NRCARDAPIO
        INTO V_NRCARDAPIO_PLA
        FROM CARDADIA
       WHERE CDFILIAL = C_CARD.CDFILIAL
         AND CDSERVFILI = C_CARD.CDSERVFILI
         AND DTCARDAPIO = C_CARD.DTCARDAPIO
         AND NRCARDAPIO <> C_CARD.NRCARDAPIO;

      UPDATE COMPCARD
         SET NRCARDAPIO = C_CARD.NRCARDAPIO
       WHERE CDFILIAL = C_CARD.CDFILIAL
         AND NRCARDAPIO = V_NRCARDAPIO_PLA;

      SELECT SUM(NVL(QTCOMESTICAR, 0)), SUM(NVL(QTCLIESTICAR, 0)), SUM(NVL(QTFUNESTICAR, 0)), SUM(NVL(QTDOAESTICAR, 0)),
             SUM(NVL(QTCOMEFETCAR, 0)), SUM(NVL(QTCLIEFETCAR, 0)), SUM(NVL(QTFUNEFETCAR, 0)), SUM(NVL(QTDOAEFETCAR, 0)),
             SUM(NVL(QTESTITURNO1, 0)), SUM(NVL(QTESTITURNO2, 0)), SUM(NVL(QTESTITURNO3, 0)), SUM(NVL(QTESTITURNO4, 0))
        INTO V_QTCOMESTICAR, V_QTCLIESTICAR, V_QTFUNESTICAR, V_QTDOAESTICAR,
             V_QTCOMEFETCAR, V_QTCLIEFETCAR, V_QTFUNEFETCAR, V_QTDOAEFETCAR,
             V_QTESTITURNO1, V_QTESTITURNO2, V_QTESTITURNO3, V_QTESTITURNO4
        FROM CARDADIA
       WHERE CDFILIAL = C_CARD.CDFILIAL
         AND CDSERVFILI = C_CARD.CDSERVFILI
         AND DTCARDAPIO = C_CARD.DTCARDAPIO;

      UPDATE CARDADIA
         SET TMP_IDCARDAPIO_DUPLICADO = NULL,
             CDDIETPAD = NULL,
             QTCOMESTICAR = V_QTCOMESTICAR,
             QTCLIESTICAR = V_QTCLIESTICAR,
             QTFUNESTICAR = V_QTFUNESTICAR,
             QTDOAESTICAR = V_QTDOAESTICAR,
             QTCOMEFETCAR = V_QTCOMEFETCAR,
             QTCLIEFETCAR = V_QTCLIEFETCAR,
             QTFUNEFETCAR = V_QTFUNEFETCAR,
             QTDOAEFETCAR = V_QTDOAEFETCAR,
             QTESTITURNO1 = V_QTESTITURNO1,
             QTESTITURNO2 = V_QTESTITURNO2,
             QTESTITURNO3 = V_QTESTITURNO3,
             QTESTITURNO4 = V_QTESTITURNO4
       WHERE CDFILIAL = C_CARD.CDFILIAL
         AND NRCARDAPIO = C_CARD.NRCARDAPIO;

       DELETE CARDADIA
        WHERE CDFILIAL = C_CARD.CDFILIAL
          AND NRCARDAPIO = V_NRCARDAPIO_PLA;
      COMMIT;
   END LOOP;
END;
/

-- MOVE OS PRATOS PARA O PRIMEIRO CARDAPIO DO PAR QUE NO TEM RETIRADA
DECLARE
   V_NRCARDAPIO_PLA CARDADIA.NRCARDAPIO%TYPE;
   V_QTCOMESTICAR FLOAT;
   V_QTCLIESTICAR FLOAT;
   V_QTFUNESTICAR FLOAT;
   V_QTDOAESTICAR FLOAT;
   V_QTCOMEFETCAR FLOAT;
   V_QTCLIEFETCAR FLOAT;
   V_QTFUNEFETCAR FLOAT;
   V_QTDOAEFETCAR FLOAT;
   V_QTESTITURNO1 FLOAT;
   V_QTESTITURNO2 FLOAT;
   V_QTESTITURNO3 FLOAT;
   V_QTESTITURNO4 FLOAT;
BEGIN
   FOR C_CARD IN (SELECT *
                    FROM (
                          SELECT SUM(1) OVER (PARTITION BY C.DTCARDAPIO, C.CDFILIAL, C.CDSERVFILI
                                                  ORDER BY C.DTCARDAPIO, C.CDFILIAL, C.CDSERVFILI
                                              ROWS BETWEEN UNBOUNDED PRECEDING AND CURRENT ROW) NRCARDAPIOSERVDIA,
                                 C.DTCARDAPIO, C.CDFILIAL, C.CDSERVFILI,
                                 C.NRCARDAPIO, NVL(C.CDDIETPAD,'NULL'), NVL(R.QTRETIRADAS, 0) QTRETIRADAS, NVL(P.QTPRATOS, 0) QTPRATOS,
                                 QTCOMESTICAR, QTCLIESTICAR, QTFUNESTICAR, QTDOAESTICAR,
                                 QTCOMEFETCAR, QTCLIEFETCAR, QTFUNEFETCAR, QTDOAEFETCAR,
                                 QTESTITURNO1, QTESTITURNO2, QTESTITURNO3, QTESTITURNO4,
                                 IDEFETINFO, VRPESPORPERC, IDFOLLOWUPRI, IDFOLLOWUPSL,
                                 QTCOMEFETRI, IDEFETINFORI, QTCOMEFETSL, IDEFETINFOSL,
                                 CDFILAUXPRRI, CDMAIORPRERI, CDFILAUXPRSL, CDMAIORPRESL,
                                 IDCADMANPRED, QTSOBRLIMPCA, QTRESTINGECA, DSCARDAPIO,
                                 DTREFECUST, IDCARDIAESPE, IDCARDLIBCEN, IDCARDLIBAGR,
                                 DSRDMUSUCARD, DSENDUSUCARD, DSNMUSUCARD, DSMETUSUCARD,
                                 CDORESPCARD, VRPESPORPERCRI
                            FROM CARDADIA C
                           INNER JOIN SERVICO S
                              ON S.CDFILIAL = C.CDFILIAL
                             AND S.CDSERVFILI = C.CDSERVFILI
                             AND S.IDTIPOSERV = 'D'
                            LEFT JOIN (SELECT CDFILIAL, NRCARDAPIO, NVL(COUNT(*),0) QTRETIRADAS
                                         FROM RETIRADA
                                        GROUP BY CDFILIAL, NRCARDAPIO) R
                              ON R.CDFILIAL = C.CDFILIAL
                             AND R.NRCARDAPIO = C.NRCARDAPIO
                            LEFT JOIN (SELECT CDFILIAL, NRCARDAPIO, NVL(COUNT(*),0) QTPRATOS
                                         FROM COMPCARD
                                        GROUP BY CDFILIAL, NRCARDAPIO) P
                              ON P.CDFILIAL = C.CDFILIAL
                             AND P.NRCARDAPIO = C.NRCARDAPIO
                           WHERE TMP_IDCARDAPIO_DUPLICADO = 'S'
                           ORDER BY C.DTCARDAPIO, C.CDFILIAL, C.CDSERVFILI, C.CDDIETPAD
                           )
                   WHERE NRCARDAPIOSERVDIA = 1
                  ) LOOP

      SELECT NRCARDAPIO
        INTO V_NRCARDAPIO_PLA
        FROM CARDADIA
       WHERE CDFILIAL = C_CARD.CDFILIAL
         AND CDSERVFILI = C_CARD.CDSERVFILI
         AND DTCARDAPIO = C_CARD.DTCARDAPIO
         AND NRCARDAPIO <> C_CARD.NRCARDAPIO;

      UPDATE COMPCARD
         SET NRCARDAPIO = C_CARD.NRCARDAPIO
       WHERE CDFILIAL = C_CARD.CDFILIAL
         AND NRCARDAPIO = V_NRCARDAPIO_PLA;

      SELECT SUM(NVL(QTCOMESTICAR, 0)), SUM(NVL(QTCLIESTICAR, 0)), SUM(NVL(QTFUNESTICAR, 0)), SUM(NVL(QTDOAESTICAR, 0)),
             SUM(NVL(QTCOMEFETCAR, 0)), SUM(NVL(QTCLIEFETCAR, 0)), SUM(NVL(QTFUNEFETCAR, 0)), SUM(NVL(QTDOAEFETCAR, 0)),
             SUM(NVL(QTESTITURNO1, 0)), SUM(NVL(QTESTITURNO2, 0)), SUM(NVL(QTESTITURNO3, 0)), SUM(NVL(QTESTITURNO4, 0))
        INTO V_QTCOMESTICAR, V_QTCLIESTICAR, V_QTFUNESTICAR, V_QTDOAESTICAR,
             V_QTCOMEFETCAR, V_QTCLIEFETCAR, V_QTFUNEFETCAR, V_QTDOAEFETCAR,
             V_QTESTITURNO1, V_QTESTITURNO2, V_QTESTITURNO3, V_QTESTITURNO4
        FROM CARDADIA
       WHERE CDFILIAL = C_CARD.CDFILIAL
         AND CDSERVFILI = C_CARD.CDSERVFILI
         AND DTCARDAPIO = C_CARD.DTCARDAPIO;

      UPDATE CARDADIA
         SET TMP_IDCARDAPIO_DUPLICADO = NULL,
             CDDIETPAD = NULL,
             QTCOMESTICAR = V_QTCOMESTICAR,
             QTCLIESTICAR = V_QTCLIESTICAR,
             QTFUNESTICAR = V_QTFUNESTICAR,
             QTDOAESTICAR = V_QTDOAESTICAR,
             QTCOMEFETCAR = V_QTCOMEFETCAR,
             QTCLIEFETCAR = V_QTCLIEFETCAR,
             QTFUNEFETCAR = V_QTFUNEFETCAR,
             QTDOAEFETCAR = V_QTDOAEFETCAR,
             QTESTITURNO1 = V_QTESTITURNO1,
             QTESTITURNO2 = V_QTESTITURNO2,
             QTESTITURNO3 = V_QTESTITURNO3,
             QTESTITURNO4 = V_QTESTITURNO4
       WHERE CDFILIAL = C_CARD.CDFILIAL
         AND NRCARDAPIO = C_CARD.NRCARDAPIO;

       DELETE CARDADIA
        WHERE CDFILIAL = C_CARD.CDFILIAL
          AND NRCARDAPIO = V_NRCARDAPIO_PLA;
      COMMIT;
   END LOOP;
END;
/

UPDATE SERVICO SET IDTIPOSERV = 'N' WHERE IDTIPOSERV = 'D'
/

COMMIT
/

-- APAGA O RESTANTE DOS CARDPIOS COM DIETA PREENCHIDA
DECLARE
   V_COUNT NUMBER;
BEGIN
   V_COUNT := 0;
   FOR C_CARD IN (SELECT CDFILIAL, NRCARDAPIO
                    FROM CARDADIA
                   WHERE CDDIETPAD IS NOT NULL) LOOP
      UPDATE CARDADIA
         SET CDDIETPAD = NULL
       WHERE CDFILIAL = C_CARD.CDFILIAL
         AND NRCARDAPIO = C_CARD.NRCARDAPIO;
      IF V_COUNT > 1000 THEN
         V_COUNT := 0;
         COMMIT;
      ELSE
         V_COUNT := V_COUNT + 1;
      END IF;
   END LOOP;
   COMMIT;
END;
/


