BEGIN
   DECLARE
      V_COUNT NUMBER;
   BEGIN
      V_COUNT := 0;
      BEGIN
         SELECT COUNT(*)
           INTO V_COUNT
           FROM USER_SCHEDULER_JOBS
          WHERE JOB_NAME = 'AGENDA_VENDA_GPS';
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_COUNT := 0;
      END;
      IF V_COUNT = 0 THEN
         DBMS_SCHEDULER.CREATE_JOB (
            job_name        => 'AGENDA_VENDA_GPS',
            job_type        => 'PLSQL_BLOCK',
            job_action      => 'BEGIN VENDA_GPS(); END;',
            start_date      => SYSDATE,
            repeat_interval => 'FREQ=HOURLY; BYHOUR=1,6,11,16,21; BYMINUTE=0; BYSECOND=0;',
            end_date        => NULL,
            enabled         => TRUE,
            auto_drop       => FALSE,
            comments        => 'Job criado para integrar os dados de fechamento de caixa e venda com a GPS.'
         );
      ELSE
         DBMS_SCHEDULER.DROP_JOB(JOB_NAME => 'AGENDA_VENDA_GPS');
         DBMS_SCHEDULER.CREATE_JOB (
            job_name        => 'AGENDA_VENDA_GPS',
            job_type        => 'PLSQL_BLOCK',
            job_action      => 'BEGIN VENDA_GPS(); END;',
            start_date      => SYSDATE,
            repeat_interval => 'FREQ=HOURLY; BYHOUR=1,6,11,16,21; BYMINUTE=0; BYSECOND=0;',
            end_date        => NULL,
            enabled         => TRUE,
            auto_drop       => FALSE,
            comments        => 'Job criado para integrar os dados de fechamento de caixa e venda com a GPS.'
         );
      END IF;
   END;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('AGENDA_VENDA_GPS','6.49.079'); END;
/
