/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_GRUPOEQUIPA                                              */
/* Tabela : GRUPOEQUIPA                                                       */
/*                                                                            */
/* Criao:                                                                   */
/* 10/09/2008 - Welbert G. Moitinha                                           */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_GRUPOEQUIPA' and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_GRUPOEQUIPA
GO

CREATE TRIGGER DTULTATU_GRUPOEQUIPA
ON GRUPOEQUIPA
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'GRUPOEQUIPA', null, 'CDGRUPOEQUIPA='+ CDGRUPOEQUIPA+ ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE GRUPOEQUIPA
      SET DTULTATUGRUPEQ = GETDATE()
      FROM INSERTED;
   END;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_GRUPOEQUIPA','5.05.016';
GO

