CREATE OR REPLACE PROCEDURE INCLUI_DADOS_EXPEDICAO
(
   P_CDFILIAL    IN EXPEDICAO.CDFILIAL%TYPE,
   P_NREXPEDICAO IN EXPEDICAO.NREXPEDICAO%TYPE,
   P_DTEXPEDICAO IN EXPEDICAO.DTEXPEDICAO%TYPE,
   P_TIPOEXP     IN EXPRELACITEMPPED.IDTIPOEXP%TYPE,
   P_CDOPERADOR  IN OPERADOR.CDOPERADOR%TYPE,
   P_NRPEDIDO    IN ITEMPEDIDO.NRPEDIDO%TYPE,
   P_NRITEMPED   IN ITEMPEDIDO.NRITEMPED%TYPE,
   P_QTITEMEXP   IN EXPRELACITEMPPED.QTITEMEXP%TYPE
)
AS
   /* Varivel para armazenar a contagem de registros existentes na tabela EXPEDICAO*/
   V_COUNT_EXPEDICAO INTEGER;
   V_COUNT_ITEM      INTEGER;
   V_NRSEQ               ERROITEMEXP.NRSEQERROITEM%TYPE;
   V_ERRO                INTEGER;
BEGIN
   /* Verifica se o registro j existe na tabela EXPEDICAO*/
   SELECT COUNT(1)
     INTO V_COUNT_EXPEDICAO
     FROM EXPEDICAO
    WHERE CDFILIAL = P_CDFILIAL
      AND NREXPEDICAO = P_NREXPEDICAO;
   /* Caso no exista, insere um novo registro*/
   IF (V_COUNT_EXPEDICAO = 0) THEN
      INSERT INTO EXPEDICAO
      (CDFILIAL, NREXPEDICAO, DTEXPEDICAO, IDSTATUSSEP, CDOPERADOR)
      VALUES
      (P_CDFILIAL, P_NREXPEDICAO,  TRUNC(P_DTEXPEDICAO), 'P', P_CDOPERADOR);
   END IF;

   V_COUNT_ITEM := 0;
   /* Processa com base no tipo de expedio */
   IF P_TIPOEXP = 'PEDIDO' THEN
      /* Itera sobre os itens relacionados ao pedido*/
      FOR C_ITEM IN (SELECT CDFILIAL, NRPEDIDO, NRITEMPED, (QTITEMPED - QTEXPITEMPED) AS QTITEMPEDEXP
                       FROM ITEMPEDIDO
                      WHERE CDFILIAL = P_CDFILIAL
                        AND NRPEDIDO = P_NRPEDIDO
                        AND IDSITITEMPED NOT IN ('5', '6'))
      LOOP
         /* Insere os itens do pedido na tabela EXPRELACITEMPPED*/
         INSERT INTO EXPRELACITEMPPED
         (CDFILIAL, NREXPEDICAO, NRPEDIDO, NRITEMPED, IDTIPOEXP, QTITEMEXP)
         VALUES
         (C_ITEM.CDFILIAL, P_NREXPEDICAO, C_ITEM.NRPEDIDO, C_ITEM.NRITEMPED, 'PEDIDO', C_ITEM.QTITEMPEDEXP);
         V_COUNT_ITEM := V_COUNT_ITEM +1;
      END LOOP;
   ELSE
      /*Insere um nico registro na tabela EXPRELACITEMPPED*/
      INSERT INTO EXPRELACITEMPPED
      (CDFILIAL, NREXPEDICAO, NRPEDIDO, NRITEMPED, IDTIPOEXP, QTITEMEXP)
      VALUES
      (P_CDFILIAL, P_NREXPEDICAO,  P_NRPEDIDO, P_NRITEMPED, P_TIPOEXP, P_QTITEMEXP);
      V_COUNT_ITEM := V_COUNT_ITEM +1;
   END IF;
END;
/
